#include <stdio.h>
#include "mpi.h"
#define MPIR_ERR_FATAL 1
#define MPIR_ERR_RECOVERABLE 0
int MPIR_Err_create_code( int, int, char *, int, int, const char [], const char [], ... );
void ChkMsg( int, int, const char [] );

int main(int argc, char **argv)
{
    int err;
    MPI_Init( 0, 0 );
    /* src/mpi/attr/attr_delete.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_attr_delete", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_attr_delete" );
    {
    /* src/mpi/attr/attr_delete.c */
    int i1 = MPI_COMM_WORLD;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_attr_delete", "**mpi_attr_delete %C %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_attr_delete %C %d" );
    }
    /* src/mpi/attr/attr_get.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_attr_get", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_attr_get" );
    {
    /* src/mpi/attr/attr_get.c */
    int i1 = MPI_COMM_WORLD;
    int i2 = 2;
    char s3[] = "pointer3";
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_attr_get", "**mpi_attr_get %C %d %p %p", i1, i2, s3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_attr_get %C %d %p %p" );
    }
    /* src/mpi/attr/attr_put.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_attr_put", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_attr_put" );
    {
    /* src/mpi/attr/attr_put.c */
    int i1 = MPI_COMM_WORLD;
    int i2 = 2;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_attr_put", "**mpi_attr_put %C %d %p", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_attr_put %C %d %p" );
    }
    /* src/mpi/attr/attrutil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**nomem", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**nomem" );
    /* src/mpi/attr/attrutil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**attrsentinal", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**attrsentinal" );
    /* src/mpi/attr/comm_delete_attr.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_KEYVAL, "**keyval", 0);
    ChkMsg( err, MPI_ERR_KEYVAL, "**keyval" );
    /* src/mpi/attr/comm_delete_attr.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_KEYVAL, "**keyvalnotcomm", 0);
    ChkMsg( err, MPI_ERR_KEYVAL, "**keyvalnotcomm" );
    /* src/mpi/attr/comm_delete_attr.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**permattr", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**permattr" );
    /* src/mpi/attr/comm_set_attr.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_KEYVAL, "**keyvalinvalid", 0);
    ChkMsg( err, MPI_ERR_KEYVAL, "**keyvalinvalid" );
    /* src/mpi/attr/comm_set_attr.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_set_attr", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_set_attr" );
    {
    /* src/mpi/attr/comm_set_attr.c */
    int i1 = MPI_COMM_WORLD;
    int i2 = 2;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_set_attr", "**mpi_comm_set_attr %C %d %p", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_set_attr %C %d %p" );
    }
    /* src/mpi/attr/keyval_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_keyval_create", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_keyval_create" );
    {
    /* src/mpi/attr/keyval_create.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_keyval_create", "**mpi_keyval_create %p %p %p %p", s1, s2, s3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_keyval_create %p %p %p %p" );
    }
    /* src/mpi/attr/keyval_free.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_keyval_free", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_keyval_free" );
    {
    /* src/mpi/attr/keyval_free.c */
    char s1[] = "pointer1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_keyval_free", "**mpi_keyval_free %p", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_keyval_free %p" );
    }
    {
    /* src/mpi/attr/type_create_keyval.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**nomem", "**nomem %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**nomem %s" );
    }
    /* src/mpi/attr/type_create_keyval.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_create_keyval", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_create_keyval" );
    {
    /* src/mpi/attr/type_create_keyval.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_create_keyval", "**mpi_type_create_keyval %p %p %p %p", s1, s2, s3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_create_keyval %p %p %p %p" );
    }
    /* src/mpi/attr/type_delete_attr.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_KEYVAL, "**keyvalnotdatatype", 0);
    ChkMsg( err, MPI_ERR_KEYVAL, "**keyvalnotdatatype" );
    /* src/mpi/attr/type_delete_attr.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_delete_attr", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_delete_attr" );
    {
    /* src/mpi/attr/type_delete_attr.c */
    int i1 = MPI_INT;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_delete_attr", "**mpi_type_delete_attr %D %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_delete_attr %D %d" );
    }
    /* src/mpi/attr/type_set_attr.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_set_attr", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_set_attr" );
    {
    /* src/mpi/attr/type_set_attr.c */
    int i1 = MPI_INT;
    int i2 = 2;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_set_attr", "**mpi_type_set_attr %D %d %p", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_set_attr %D %d %p" );
    }
    /* src/mpi/attr/win_create_keyval.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_create_keyval", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_create_keyval" );
    {
    /* src/mpi/attr/win_create_keyval.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_create_keyval", "**mpi_win_create_keyval %p %p %p %p", s1, s2, s3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_create_keyval %p %p %p %p" );
    }
    /* src/mpi/attr/win_delete_attr.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_KEYVAL, "**keyvalnotwin", 0);
    ChkMsg( err, MPI_ERR_KEYVAL, "**keyvalnotwin" );
    /* src/mpi/attr/win_delete_attr.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_delete_attr", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_delete_attr" );
    {
    /* src/mpi/attr/win_delete_attr.c */
    int i1 = MPI_WIN_NULL;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_delete_attr", "**mpi_win_delete_attr %W %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_delete_attr %W %d" );
    }
    /* src/mpi/attr/win_set_attr.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_set_attr", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_set_attr" );
    {
    /* src/mpi/attr/win_set_attr.c */
    int i1 = MPI_WIN_NULL;
    int i2 = 2;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_set_attr", "**mpi_win_set_attr %W %d %p", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_set_attr %W %d %p" );
    }
    /* src/mpi/coll/allgather.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_allgather", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_allgather" );
    {
    /* src/mpi/coll/allgather.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    char s4[] = "pointer4";
    int i5 = 5;
    int i6 = MPI_INT;
    int i7 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_allgather", "**mpi_allgather %p %d %D %p %d %D %C", s1, i2, i3, s4, i5, i6, i7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_allgather %p %d %D %p %d %D %C" );
    }
    /* src/mpi/coll/allgatherv.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_allgatherv", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_allgatherv" );
    {
    /* src/mpi/coll/allgatherv.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    char s4[] = "pointer4";
    char s5[] = "pointer5";
    char s6[] = "pointer6";
    int i7 = MPI_INT;
    int i8 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_allgatherv", "**mpi_allgatherv %p %d %D %p %p %p %D %C", s1, i2, i3, s4, s5, s6, i7, i8 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_allgatherv %p %d %D %p %p %p %D %C" );
    }
    /* src/mpi/coll/allreduce.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_allreduce", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_allreduce" );
    {
    /* src/mpi/coll/allreduce.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    int i3 = 3;
    int i4 = MPI_INT;
    int i5 = MPI_SUM;
    int i6 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_allreduce", "**mpi_allreduce %p %p %d %D %O %C", s1, s2, i3, i4, i5, i6 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_allreduce %p %p %d %D %O %C" );
    }
    /* src/mpi/coll/alltoall.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_alltoall", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_alltoall" );
    {
    /* src/mpi/coll/alltoall.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    char s4[] = "pointer4";
    int i5 = 5;
    int i6 = MPI_INT;
    int i7 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_alltoall", "**mpi_alltoall %p %d %D %p %d %D %C", s1, i2, i3, s4, i5, i6, i7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_alltoall %p %d %D %p %d %D %C" );
    }
    /* src/mpi/coll/alltoallv.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_alltoallv", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_alltoallv" );
    {
    /* src/mpi/coll/alltoallv.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    int i4 = MPI_INT;
    char s5[] = "pointer5";
    char s6[] = "pointer6";
    char s7[] = "pointer7";
    int i8 = MPI_INT;
    int i9 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_alltoallv", "**mpi_alltoallv %p %p %p %D %p %p %p %D %C", s1, s2, s3, i4, s5, s6, s7, i8, i9 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_alltoallv %p %p %p %D %p %p %p %D %C" );
    }
    /* src/mpi/coll/alltoallw.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_alltoallw", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_alltoallw" );
    {
    /* src/mpi/coll/alltoallw.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    char s5[] = "pointer5";
    char s6[] = "pointer6";
    char s7[] = "pointer7";
    char s8[] = "pointer8";
    int i9 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_alltoallw", "**mpi_alltoallw %p %p %p %p %p %p %p %p %C", s1, s2, s3, s4, s5, s6, s7, s8, i9 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_alltoallw %p %p %p %p %p %p %p %p %C" );
    }
    /* src/mpi/coll/barrier.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_barrier", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_barrier" );
    {
    /* src/mpi/coll/barrier.c */
    int i1 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_barrier", "**mpi_barrier %C", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_barrier %C" );
    }
    {
    /* src/mpi/coll/bcast.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**nomem", "**nomem %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**nomem %d" );
    }
    /* src/mpi/coll/bcast.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**fail", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**fail" );
    /* src/mpi/coll/bcast.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_bcast", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_bcast" );
    {
    /* src/mpi/coll/bcast.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_bcast", "**mpi_bcast %p %d %D %d %C", s1, i2, i3, i4, i5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_bcast %p %d %D %d %C" );
    }
    /* src/mpi/coll/exscan.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_exscan", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_exscan" );
    {
    /* src/mpi/coll/exscan.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    int i3 = 3;
    int i4 = MPI_INT;
    int i5 = MPI_SUM;
    int i6 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_exscan", "**mpi_exscan %p %p %d %D %O %C", s1, s2, i3, i4, i5, i6 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_exscan %p %p %d %D %O %C" );
    }
    /* src/mpi/coll/gather.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_gather", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_gather" );
    {
    /* src/mpi/coll/gather.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    char s4[] = "pointer4";
    int i5 = 5;
    int i6 = MPI_INT;
    int i7 = 7;
    int i8 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_gather", "**mpi_gather %p %d %D %p %d %D %d %C", s1, i2, i3, s4, i5, i6, i7, i8 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_gather %p %d %D %p %d %D %d %C" );
    }
    /* src/mpi/coll/gatherv.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_gatherv", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_gatherv" );
    {
    /* src/mpi/coll/gatherv.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    char s4[] = "pointer4";
    char s5[] = "pointer5";
    char s6[] = "pointer6";
    int i7 = MPI_INT;
    int i8 = 8;
    int i9 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_gatherv", "**mpi_gatherv %p %d %D %p %p %p %D %d %C", s1, i2, i3, s4, s5, s6, i7, i8, i9 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_gatherv %p %d %D %p %p %p %D %d %C" );
    }
    /* src/mpi/coll/op_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_op_create", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_op_create" );
    {
    /* src/mpi/coll/op_create.c */
    char s1[] = "pointer1";
    int i2 = 2;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_op_create", "**mpi_op_create %p %d %p", s1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_op_create %p %d %p" );
    }
    /* src/mpi/coll/op_free.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OP, "**permop", 0);
    ChkMsg( err, MPI_ERR_OP, "**permop" );
    /* src/mpi/coll/opband.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OP, "**opundefined", 0);
    ChkMsg( err, MPI_ERR_OP, "**opundefined" );
    {
    /* src/mpi/coll/opband.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OP, "**opundefined", "**opundefined %s", s1 );
    ChkMsg( err, MPI_ERR_OP, "**opundefined %s" );
    }
    /* src/mpi/coll/red_scat.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_reduce_scatter", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_reduce_scatter" );
    {
    /* src/mpi/coll/red_scat.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    int i4 = MPI_INT;
    int i5 = MPI_SUM;
    int i6 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_reduce_scatter", "**mpi_reduce_scatter %p %p %p %D %O %C", s1, s2, s3, i4, i5, i6 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_reduce_scatter %p %p %p %D %O %C" );
    }
    /* src/mpi/coll/reduce.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_reduce", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_reduce" );
    {
    /* src/mpi/coll/reduce.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    int i3 = 3;
    int i4 = MPI_INT;
    int i5 = MPI_SUM;
    int i6 = 6;
    int i7 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_reduce", "**mpi_reduce %p %p %d %D %O %d %C", s1, s2, i3, i4, i5, i6, i7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_reduce %p %p %d %D %O %d %C" );
    }
    /* src/mpi/coll/scan.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_scan", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_scan" );
    {
    /* src/mpi/coll/scan.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    int i3 = 3;
    int i4 = MPI_INT;
    int i5 = MPI_SUM;
    int i6 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_scan", "**mpi_scan %p %p %d %D %O %C", s1, s2, i3, i4, i5, i6 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_scan %p %p %d %D %O %C" );
    }
    /* src/mpi/coll/scatter.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_scatter", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_scatter" );
    {
    /* src/mpi/coll/scatter.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    char s4[] = "pointer4";
    int i5 = 5;
    int i6 = MPI_INT;
    int i7 = 7;
    int i8 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_scatter", "**mpi_scatter %p %d %D %p %d %D %d %C", s1, i2, i3, s4, i5, i6, i7, i8 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_scatter %p %d %D %p %d %D %d %C" );
    }
    /* src/mpi/coll/scatterv.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_scatterv", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_scatterv" );
    {
    /* src/mpi/coll/scatterv.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    int i4 = MPI_INT;
    char s5[] = "pointer5";
    int i6 = 6;
    int i7 = MPI_INT;
    int i8 = 8;
    int i9 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_scatterv", "**mpi_scatterv %p %p %p %D %p %d %D %d %C", s1, s2, s3, i4, s5, i6, i7, i8, i9 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_scatterv %p %p %p %D %p %d %D %d %C" );
    }
    /* src/mpi/comm/comm_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**toomanycomm", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**toomanycomm" );
    /* src/mpi/comm/comm_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_GROUP, "**groupnotincomm", 0);
    ChkMsg( err, MPI_ERR_GROUP, "**groupnotincomm" );
    {
    /* src/mpi/comm/comm_create.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_GROUP, "**groupnotincomm", "**groupnotincomm %d", i1 );
    ChkMsg( err, MPI_ERR_GROUP, "**groupnotincomm %d" );
    }
    /* src/mpi/comm/comm_dup.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_dup", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_dup" );
    {
    /* src/mpi/comm/comm_dup.c */
    int i1 = MPI_COMM_WORLD;
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_dup", "**mpi_comm_dup %C %p", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_dup %C %p" );
    }
    /* src/mpi/comm/comm_free.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_COMM, "**commperm", 0);
    ChkMsg( err, MPI_ERR_COMM, "**commperm" );
    {
    /* src/mpi/comm/comm_free.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_COMM, "**commperm", "**commperm %s", s1 );
    ChkMsg( err, MPI_ERR_COMM, "**commperm %s" );
    }
    /* src/mpi/comm/comm_free.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_free", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_free" );
    {
    /* src/mpi/comm/comm_free.c */
    char s1[] = "pointer1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_free", "**mpi_comm_free %p", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_free %p" );
    }
    /* src/mpi/comm/comm_group.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_group", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_group" );
    {
    /* src/mpi/comm/comm_group.c */
    int i1 = MPI_COMM_WORLD;
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_group", "**mpi_comm_group %C %p", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_group %C %p" );
    }
    /* src/mpi/comm/comm_remote_group.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_COMM, "**commnotinter", 0);
    ChkMsg( err, MPI_ERR_COMM, "**commnotinter" );
    /* src/mpi/comm/comm_remote_group.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_remote_group", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_remote_group" );
    {
    /* src/mpi/comm/comm_remote_group.c */
    int i1 = MPI_COMM_WORLD;
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_remote_group", "**mpi_comm_remote_group %C %p", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_remote_group %C %p" );
    }
    /* src/mpi/comm/comm_split.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_split", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_split" );
    {
    /* src/mpi/comm/comm_split.c */
    int i1 = MPI_COMM_WORLD;
    int i2 = 2;
    int i3 = 3;
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_split", "**mpi_comm_split %C %d %d %p", i1, i2, i3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_split %C %d %d %p" );
    }
    /* src/mpi/comm/intercomm_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**intern", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**intern" );
    {
    /* src/mpi/comm/intercomm_create.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**intern", "**intern %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**intern %s" );
    }
    /* src/mpi/comm/intercomm_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_COMM, "**dupprocesses", 0);
    ChkMsg( err, MPI_ERR_COMM, "**dupprocesses" );
    {
    /* src/mpi/comm/intercomm_create.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_COMM, "**dupprocesses", "**dupprocesses %d", i1 );
    ChkMsg( err, MPI_ERR_COMM, "**dupprocesses %d" );
    }
    /* src/mpi/comm/intercomm_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_RANK, "**ranklocal", 0);
    ChkMsg( err, MPI_ERR_RANK, "**ranklocal" );
    {
    /* src/mpi/comm/intercomm_create.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_RANK, "**ranklocal", "**ranklocal %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_RANK, "**ranklocal %d %d" );
    }
    /* src/mpi/comm/intercomm_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_RANK, "**rankremote", 0);
    ChkMsg( err, MPI_ERR_RANK, "**rankremote" );
    {
    /* src/mpi/comm/intercomm_create.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_RANK, "**rankremote", "**rankremote %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_RANK, "**rankremote %d %d" );
    }
    /* src/mpi/comm/intercomm_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_intercomm_create", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_intercomm_create" );
    {
    /* src/mpi/comm/intercomm_create.c */
    int i1 = MPI_COMM_WORLD;
    int i2 = 2;
    int i3 = MPI_COMM_WORLD;
    int i4 = 4;
    int i5 = 5;
    char s6[] = "pointer6";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_intercomm_create", "**mpi_intercomm_create %C %d %C %d %d %p", i1, i2, i3, i4, i5, s6 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_intercomm_create %C %d %C %d %d %p" );
    }
    /* src/mpi/comm/intercomm_merge.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**notsame", 0);
    ChkMsg( err, MPI_ERR_ARG, "**notsame" );
    {
    /* src/mpi/comm/intercomm_merge.c */
    char s1[] = "string1";
    char s2[] = "string2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**notsame", "**notsame %s %s", s1, s2 );
    ChkMsg( err, MPI_ERR_ARG, "**notsame %s %s" );
    }
    /* src/mpi/comm/intercomm_merge.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_intercomm_merge", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_intercomm_merge" );
    {
    /* src/mpi/comm/intercomm_merge.c */
    int i1 = MPI_COMM_WORLD;
    int i2 = 2;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_intercomm_merge", "**mpi_intercomm_merge %C %d %p", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_intercomm_merge %C %d %p" );
    }
    /* src/mpi/datatype/pack.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**arg", 0);
    ChkMsg( err, MPI_ERR_ARG, "**arg" );
    /* src/mpi/datatype/pack.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_pack", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_pack" );
    {
    /* src/mpi/datatype/pack.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    char s4[] = "pointer4";
    int i5 = 5;
    char s6[] = "pointer6";
    int i7 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_pack", "**mpi_pack %p %d %D %p %d %p %C", s1, i2, i3, s4, i5, s6, i7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_pack %p %d %D %p %d %p %C" );
    }
    /* src/mpi/datatype/pack_external.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_pack_external", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_pack_external" );
    {
    /* src/mpi/datatype/pack_external.c */
    char s1[] = "string1";
    char s2[] = "pointer2";
    int i3 = 3;
    int i4 = MPI_INT;
    char s5[] = "pointer5";
    int i6 = 6;
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_pack_external", "**mpi_pack_external %s %p %d %D %p %d %p", s1, s2, i3, i4, s5, i6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_pack_external %s %p %d %D %p %d %p" );
    }
    /* src/mpi/datatype/register_datarep.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_register_datarep", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_register_datarep" );
    {
    /* src/mpi/datatype/register_datarep.c */
    char s1[] = "string1";
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_register_datarep", "**mpi_register_datarep %s %p %p %p %p", s1, s2, s3, s4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_register_datarep %s %p %p %p %p" );
    }
    /* src/mpi/datatype/type_commit.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_commit", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_commit" );
    {
    /* src/mpi/datatype/type_commit.c */
    char s1[] = "pointer1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_commit", "**mpi_type_commit %p", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_commit %p" );
    }
    /* src/mpi/datatype/type_contiguous.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_contiguous", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_contiguous" );
    {
    /* src/mpi/datatype/type_contiguous.c */
    int i1 = 1;
    int i2 = MPI_INT;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_contiguous", "**mpi_type_contiguous %d %D %p", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_contiguous %d %D %p" );
    }
    /* src/mpi/datatype/type_create_hindexed.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_create_hindexed", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_create_hindexed" );
    {
    /* src/mpi/datatype/type_create_hindexed.c */
    int i1 = 1;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    int i4 = MPI_INT;
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_create_hindexed", "**mpi_type_create_hindexed %d %p %p %D %p", i1, s2, s3, i4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_create_hindexed %d %p %p %D %p" );
    }
    /* src/mpi/datatype/type_create_hvector.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_create_hvector", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_create_hvector" );
    {
    /* src/mpi/datatype/type_create_hvector.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
    int i4 = MPI_INT;
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_create_hvector", "**mpi_type_create_hvector %d %d %d %D %p", i1, i2, i3, i4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_create_hvector %d %d %d %D %p" );
    }
    /* src/mpi/datatype/type_create_indexed_block.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_create_indexed_block", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_create_indexed_block" );
    {
    /* src/mpi/datatype/type_create_indexed_block.c */
    int i1 = 1;
    int i2 = 2;
    char s3[] = "pointer3";
    int i4 = MPI_INT;
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_create_indexed_block", "**mpi_type_create_indexed_block %d %d %p %D %p", i1, i2, s3, i4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_create_indexed_block %d %d %p %D %p" );
    }
    /* src/mpi/datatype/type_create_resized.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_create_resized", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_create_resized" );
    {
    /* src/mpi/datatype/type_create_resized.c */
    int i1 = MPI_INT;
    int i2 = 2;
    int i3 = 3;
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_create_resized", "**mpi_type_create_resized %D %d %d %p", i1, i2, i3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_create_resized %D %d %d %p" );
    }
    /* src/mpi/datatype/type_create_struct.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_create_struct", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_create_struct" );
    {
    /* src/mpi/datatype/type_create_struct.c */
    int i1 = 1;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_create_struct", "**mpi_type_create_struct %d %p %p %p %p", i1, s2, s3, s4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_create_struct %d %p %p %p %p" );
    }
    /* src/mpi/datatype/type_dup.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_dup", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_dup" );
    {
    /* src/mpi/datatype/type_dup.c */
    int i1 = MPI_INT;
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_dup", "**mpi_type_dup %D %p", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_dup %D %p" );
    }
    /* src/mpi/datatype/type_free.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TYPE, "**dtypeperm", 0);
    ChkMsg( err, MPI_ERR_TYPE, "**dtypeperm" );
    /* src/mpi/datatype/type_get_contents.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**initialized", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**initialized" );
    /* src/mpi/datatype/type_get_contents.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_get_contents", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_get_contents" );
    {
    /* src/mpi/datatype/type_get_contents.c */
    int i1 = MPI_INT;
    int i2 = 2;
    int i3 = 3;
    int i4 = 4;
    char s5[] = "pointer5";
    char s6[] = "pointer6";
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_get_contents", "**mpi_type_get_contents %D %d %d %d %p %p %p", i1, i2, i3, i4, s5, s6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_get_contents %D %d %d %d %p %p %p" );
    }
    /* src/mpi/datatype/type_get_envelope.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_get_envelope", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_get_envelope" );
    {
    /* src/mpi/datatype/type_get_envelope.c */
    int i1 = MPI_INT;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_get_envelope", "**mpi_type_get_envelope %D %p %p %p %p", i1, s2, s3, s4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_get_envelope %D %p %p %p %p" );
    }
    /* src/mpi/datatype/type_hindexed.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_hindexed", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_hindexed" );
    {
    /* src/mpi/datatype/type_hindexed.c */
    int i1 = 1;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    int i4 = MPI_INT;
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_hindexed", "**mpi_type_hindexed %d %p %p %D %p", i1, s2, s3, i4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_hindexed %d %p %p %D %p" );
    }
    /* src/mpi/datatype/type_hvector.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_hvector", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_hvector" );
    {
    /* src/mpi/datatype/type_hvector.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
    int i4 = MPI_INT;
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_hvector", "**mpi_type_hvector %d %d %d %D %p", i1, i2, i3, i4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_hvector %d %d %d %D %p" );
    }
    /* src/mpi/datatype/type_indexed.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_indexed", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_indexed" );
    {
    /* src/mpi/datatype/type_indexed.c */
    int i1 = 1;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    int i4 = MPI_INT;
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_indexed", "**mpi_type_indexed %d %p %p %D %p", i1, s2, s3, i4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_indexed %d %p %p %D %p" );
    }
    /* src/mpi/datatype/type_match_size.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**typematchnoclass", 0);
    ChkMsg( err, MPI_ERR_ARG, "**typematchnoclass" );
    /* src/mpi/datatype/type_match_size.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**typematchsize", 0);
    ChkMsg( err, MPI_ERR_ARG, "**typematchsize" );
    {
    /* src/mpi/datatype/type_match_size.c */
    char s1[] = "string1";
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**typematchsize", "**typematchsize %s %d", s1, i2 );
    ChkMsg( err, MPI_ERR_ARG, "**typematchsize %s %d" );
    }
    /* src/mpi/datatype/type_match_size.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_match_size", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_match_size" );
    {
    /* src/mpi/datatype/type_match_size.c */
    int i1 = 1;
    int i2 = 2;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_match_size", "**mpi_type_match_size %d %d %p", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_match_size %d %d %p" );
    }
    /* src/mpi/datatype/type_set_name.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**typenamelen", 0);
    ChkMsg( err, MPI_ERR_ARG, "**typenamelen" );
    {
    /* src/mpi/datatype/type_set_name.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**typenamelen", "**typenamelen %d", i1 );
    ChkMsg( err, MPI_ERR_ARG, "**typenamelen %d" );
    }
    /* src/mpi/datatype/type_struct.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_struct", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_struct" );
    {
    /* src/mpi/datatype/type_struct.c */
    int i1 = 1;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_struct", "**mpi_type_struct %d %p %p %p %p", i1, s2, s3, s4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_struct %d %p %p %p %p" );
    }
    /* src/mpi/datatype/type_vector.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_vector", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_vector" );
    {
    /* src/mpi/datatype/type_vector.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
    int i4 = MPI_INT;
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_type_vector", "**mpi_type_vector %d %d %d %D %p", i1, i2, i3, i4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_type_vector %d %d %d %D %p" );
    }
    /* src/mpi/datatype/unpack_external.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_unpack_external", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_unpack_external" );
    {
    /* src/mpi/datatype/unpack_external.c */
    char s1[] = "string1";
    char s2[] = "pointer2";
    int i3 = 3;
    char s4[] = "pointer4";
    char s5[] = "pointer5";
    int i6 = 6;
    int i7 = MPI_INT;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_unpack_external", "**mpi_unpack_external %s %p %d %p %p %d %D", s1, s2, i3, s4, s5, i6, i7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_unpack_external %s %p %d %p %p %d %D" );
    }
    /* src/mpi/errhan/add_error_class.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**noerrclasses", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**noerrclasses" );
    /* src/mpi/errhan/add_error_code.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**noerrcodes", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**noerrcodes" );
    /* src/mpi/errhan/add_error_string.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_add_error_string", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_add_error_string" );
    {
    /* src/mpi/errhan/add_error_string.c */
    int i1 = 1;
    char s2[] = "string2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_add_error_string", "**mpi_add_error_string %d %s", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_add_error_string %d %s" );
    }
    /* src/mpi/errhan/dynerrutil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**argerrcode", 0);
    ChkMsg( err, MPI_ERR_ARG, "**argerrcode" );
    {
    /* src/mpi/errhan/dynerrutil.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**argerrcode", "**argerrcode %d", i1 );
    ChkMsg( err, MPI_ERR_ARG, "**argerrcode %d" );
    }
    {
    /* src/mpi/errhan/dynerrutil.c */
    char s1[] = "string1";
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**nomem", "**nomem %s %d", s1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**nomem %s %d" );
    }
    /* src/mpi/errhan/errhandler_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_errhandler_create", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_errhandler_create" );
    {
    /* src/mpi/errhan/errhandler_create.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_errhandler_create", "**mpi_errhandler_create %p %p", s1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_errhandler_create %p %p" );
    }
    /* src/mpi/errhan/errhandler_get.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_errhandler_get", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_errhandler_get" );
    {
    /* src/mpi/errhan/errhandler_get.c */
    int i1 = MPI_COMM_WORLD;
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_errhandler_get", "**mpi_errhandler_get %C %p", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_errhandler_get %C %p" );
    }
    /* src/mpi/errhan/errhandler_set.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_errhandler_set", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_errhandler_set" );
    {
    /* src/mpi/errhan/errhandler_set.c */
    int i1 = MPI_COMM_WORLD;
    int i2 = MPI_ERRORS_RETURN;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_errhandler_set", "**mpi_errhandler_set %C %E", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_errhandler_set %C %E" );
    }
    /* src/mpi/errhan/file_create_errhandler.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_file_create_errhandler", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_file_create_errhandler" );
    {
    /* src/mpi/errhan/file_create_errhandler.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_file_create_errhandler", "**mpi_file_create_errhandler %p %p", s1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_file_create_errhandler %p %p" );
    }
    /* src/mpi/errhan/file_set_errhandler.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**errhandnotfile", 0);
    ChkMsg( err, MPI_ERR_ARG, "**errhandnotfile" );
    /* src/mpi/errhan/win_create_errhandler.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_create_errhandler", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_create_errhandler" );
    {
    /* src/mpi/errhan/win_create_errhandler.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_create_errhandler", "**mpi_win_create_errhandler %p %p", s1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_create_errhandler %p %p" );
    }
    /* src/mpi/errhan/win_set_errhandler.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**errhandnotwin", 0);
    ChkMsg( err, MPI_ERR_ARG, "**errhandnotwin" );
    /* src/mpi/group/group_difference.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_difference", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_difference" );
    {
    /* src/mpi/group/group_difference.c */
    int i1 = MPI_GROUP_NULL;
    int i2 = MPI_GROUP_NULL;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_difference", "**mpi_group_difference %G %G %p", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_difference %G %G %p" );
    }
    /* src/mpi/group/group_excl.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_excl", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_excl" );
    {
    /* src/mpi/group/group_excl.c */
    int i1 = MPI_GROUP_NULL;
    int i2 = 2;
    char s3[] = "pointer3";
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_excl", "**mpi_group_excl %G %d %p %p", i1, i2, s3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_excl %G %d %p %p" );
    }
    /* src/mpi/group/group_free.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_free", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_free" );
    {
    /* src/mpi/group/group_free.c */
    char s1[] = "pointer1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_free", "**mpi_group_free %p", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_free %p" );
    }
    /* src/mpi/group/group_incl.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_incl", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_incl" );
    {
    /* src/mpi/group/group_incl.c */
    int i1 = MPI_GROUP_NULL;
    int i2 = 2;
    char s3[] = "pointer3";
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_incl", "**mpi_group_incl %G %d %p %p", i1, i2, s3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_incl %G %d %p %p" );
    }
    /* src/mpi/group/group_intersection.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_intersection", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_intersection" );
    {
    /* src/mpi/group/group_intersection.c */
    int i1 = MPI_GROUP_NULL;
    int i2 = MPI_GROUP_NULL;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_intersection", "**mpi_group_intersection %G %G %p", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_intersection %G %G %p" );
    }
    /* src/mpi/group/group_range_excl.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_range_excl", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_range_excl" );
    {
    /* src/mpi/group/group_range_excl.c */
    int i1 = MPI_GROUP_NULL;
    int i2 = 2;
    char s3[] = "pointer3";
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_range_excl", "**mpi_group_range_excl %G %d %p %p", i1, i2, s3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_range_excl %G %d %p %p" );
    }
    /* src/mpi/group/group_range_incl.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_range_incl", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_range_incl" );
    {
    /* src/mpi/group/group_range_incl.c */
    int i1 = MPI_GROUP_NULL;
    int i2 = 2;
    char s3[] = "pointer3";
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_range_incl", "**mpi_group_range_incl %G %d %p %p", i1, i2, s3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_range_incl %G %d %p %p" );
    }
    /* src/mpi/group/group_translate_ranks.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_RANK, "**rank", 0);
    ChkMsg( err, MPI_ERR_RANK, "**rank" );
    {
    /* src/mpi/group/group_translate_ranks.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_RANK, "**rank", "**rank %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_RANK, "**rank %d %d" );
    }
    /* src/mpi/group/group_union.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_union", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_union" );
    {
    /* src/mpi/group/group_union.c */
    int i1 = MPI_GROUP_NULL;
    int i2 = MPI_GROUP_NULL;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_group_union", "**mpi_group_union %G %G %p", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_group_union %G %G %p" );
    }
    /* src/mpi/group/grouputil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**argneg", 0);
    ChkMsg( err, MPI_ERR_ARG, "**argneg" );
    {
    /* src/mpi/group/grouputil.c */
    char s1[] = "string1";
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**argneg", "**argneg %s %d", s1, i2 );
    ChkMsg( err, MPI_ERR_ARG, "**argneg %s %d" );
    }
    /* src/mpi/group/grouputil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_RANK, "**rankarray", 0);
    ChkMsg( err, MPI_ERR_RANK, "**rankarray" );
    {
    /* src/mpi/group/grouputil.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_RANK, "**rankarray", "**rankarray %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_RANK, "**rankarray %d %d %d" );
    }
    /* src/mpi/group/grouputil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_RANK, "**rankdup", 0);
    ChkMsg( err, MPI_ERR_RANK, "**rankdup" );
    {
    /* src/mpi/group/grouputil.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_RANK, "**rankdup", "**rankdup %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_RANK, "**rankdup %d %d %d" );
    }
    /* src/mpi/group/grouputil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**rangestartinvalid", 0);
    ChkMsg( err, MPI_ERR_ARG, "**rangestartinvalid" );
    {
    /* src/mpi/group/grouputil.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**rangestartinvalid", "**rangestartinvalid %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_ARG, "**rangestartinvalid %d %d %d" );
    }
    /* src/mpi/group/grouputil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**stridezero", 0);
    ChkMsg( err, MPI_ERR_ARG, "**stridezero" );
    /* src/mpi/group/grouputil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**rangeendinvalid", 0);
    ChkMsg( err, MPI_ERR_ARG, "**rangeendinvalid" );
    {
    /* src/mpi/group/grouputil.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**rangeendinvalid", "**rangeendinvalid %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_ARG, "**rangeendinvalid %d %d %d" );
    }
    /* src/mpi/group/grouputil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**stride", 0);
    ChkMsg( err, MPI_ERR_ARG, "**stride" );
    {
    /* src/mpi/group/grouputil.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**stride", "**stride %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_ARG, "**stride %d %d %d" );
    }
    /* src/mpi/group/grouputil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**rangedup", 0);
    ChkMsg( err, MPI_ERR_ARG, "**rangedup" );
    {
    /* src/mpi/group/grouputil.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**rangedup", "**rangedup %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_ARG, "**rangedup %d %d %d" );
    }
    /* src/mpi/init/abort.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**abort", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**abort" );
    /* src/mpi/init/init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**inittwice", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**inittwice" );
    /* src/mpi/init/init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_init", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_init" );
    {
    /* src/mpi/init/init.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_init", "**mpi_init %p %p", s1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_init %p %p" );
    }
    /* src/mpi/init/initthread.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**init", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**init" );
    /* src/mpi/init/initthread.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_init_thread", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_init_thread" );
    {
    /* src/mpi/init/initthread.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    int i3 = 3;
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_init_thread", "**mpi_init_thread %p %p %d %p", s1, s2, i3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_init_thread %p %p %d %p" );
    }
    /* src/mpi/misc/getpname.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_get_processor_name", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_get_processor_name" );
    {
    /* src/mpi/misc/getpname.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_get_processor_name", "**mpi_get_processor_name %p %p", s1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_get_processor_name %p %p" );
    }
    /* src/mpi/pt2pt/bsend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_bsend", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_bsend" );
    {
    /* src/mpi/pt2pt/bsend.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_bsend", "**mpi_bsend %p %d %D %d %d %C", s1, i2, i3, i4, i5, i6 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_bsend %p %d %D %d %d %C" );
    }
    /* src/mpi/pt2pt/bsend_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_bsend_init", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_bsend_init" );
    {
    /* src/mpi/pt2pt/bsend_init.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_bsend_init", "**mpi_bsend_init %p %d %D %d %d %C %p", s1, i2, i3, i4, i5, i6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_bsend_init %p %d %D %d %d %C %p" );
    }
    /* src/mpi/pt2pt/bsendutil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BUFFER, "**bufexists", 0);
    ChkMsg( err, MPI_ERR_BUFFER, "**bufexists" );
    /* src/mpi/pt2pt/bsendutil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BUFFER, "**bsendbufsmall", 0);
    ChkMsg( err, MPI_ERR_BUFFER, "**bsendbufsmall" );
    {
    /* src/mpi/pt2pt/bsendutil.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BUFFER, "**bsendbufsmall", "**bsendbufsmall %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_BUFFER, "**bsendbufsmall %d %d" );
    }
    /* src/mpi/pt2pt/bsendutil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**notimpl", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**notimpl" );
    /* src/mpi/pt2pt/bsendutil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**bsendnobuf", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**bsendnobuf" );
    /* src/mpi/pt2pt/bsendutil.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BUFFER, "**bufbsend", 0);
    ChkMsg( err, MPI_ERR_BUFFER, "**bufbsend" );
    {
    /* src/mpi/pt2pt/bsendutil.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BUFFER, "**bufbsend", "**bufbsend %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_BUFFER, "**bufbsend %d %d" );
    }
    /* src/mpi/pt2pt/bufattach.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_buffer_attach", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_buffer_attach" );
    {
    /* src/mpi/pt2pt/bufattach.c */
    char s1[] = "pointer1";
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_buffer_attach", "**mpi_buffer_attach %p %d", s1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_buffer_attach %p %d" );
    }
    /* src/mpi/pt2pt/buffree.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_buffer_detach", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_buffer_detach" );
    {
    /* src/mpi/pt2pt/buffree.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_buffer_detach", "**mpi_buffer_detach %p %p", s1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_buffer_detach %p %p" );
    }
    /* src/mpi/pt2pt/cancel.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_cancel", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_cancel" );
    {
    /* src/mpi/pt2pt/cancel.c */
    char s1[] = "pointer1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_cancel", "**mpi_cancel %p", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_cancel %p" );
    }
    /* src/mpi/pt2pt/cancel.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_REQUEST, "**requestpersistactive", 0);
    ChkMsg( err, MPI_ERR_REQUEST, "**requestpersistactive" );
    /* src/mpi/pt2pt/cancel.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_INTERN, "**cancelunknown", 0);
    ChkMsg( err, MPI_ERR_INTERN, "**cancelunknown" );
    /* src/mpi/pt2pt/greq_complete.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**notgenreq", 0);
    ChkMsg( err, MPI_ERR_ARG, "**notgenreq" );
    /* src/mpi/pt2pt/greq_start.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_grequest_start", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_grequest_start" );
    {
    /* src/mpi/pt2pt/greq_start.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_grequest_start", "**mpi_grequest_start %p %p %p %p %p", s1, s2, s3, s4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_grequest_start %p %p %p %p %p" );
    }
    /* src/mpi/pt2pt/ibsend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_ibsend", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_ibsend" );
    {
    /* src/mpi/pt2pt/ibsend.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_ibsend", "**mpi_ibsend %p %d %D %d %d %C %p", s1, i2, i3, i4, i5, i6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_ibsend %p %d %D %d %d %C %p" );
    }
    /* src/mpi/pt2pt/iprobe.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_iprobe", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_iprobe" );
    {
    /* src/mpi/pt2pt/iprobe.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = MPI_COMM_WORLD;
    char s4[] = "pointer4";
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_iprobe", "**mpi_iprobe %d %d %C %p %p", i1, i2, i3, s4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_iprobe %d %d %C %p %p" );
    }
    /* src/mpi/pt2pt/irecv.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_irecv", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_irecv" );
    {
    /* src/mpi/pt2pt/irecv.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_irecv", "**mpi_irecv %p %d %D %d %d %C %p", s1, i2, i3, i4, i5, i6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_irecv %p %d %D %d %d %C %p" );
    }
    /* src/mpi/pt2pt/irsend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_irsend", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_irsend" );
    {
    /* src/mpi/pt2pt/irsend.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_irsend", "**mpi_irsend %p %d %D %d %d %C %p", s1, i2, i3, i4, i5, i6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_irsend %p %d %D %d %d %C %p" );
    }
    /* src/mpi/pt2pt/isend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_isend", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_isend" );
    {
    /* src/mpi/pt2pt/isend.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_isend", "**mpi_isend %p %d %D %d %d %C %p", s1, i2, i3, i4, i5, i6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_isend %p %d %D %d %d %C %p" );
    }
    /* src/mpi/pt2pt/issend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_issend", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_issend" );
    {
    /* src/mpi/pt2pt/issend.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_issend", "**mpi_issend %p %d %D %d %d %C %p", s1, i2, i3, i4, i5, i6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_issend %p %d %D %d %d %C %p" );
    }
    /* src/mpi/pt2pt/probe.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_probe", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_probe" );
    {
    /* src/mpi/pt2pt/probe.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = MPI_COMM_WORLD;
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_probe", "**mpi_probe %d %d %C %p", i1, i2, i3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_probe %d %d %C %p" );
    }
    /* src/mpi/pt2pt/recv.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_recv", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_recv" );
    {
    /* src/mpi/pt2pt/recv.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_recv", "**mpi_recv %p %d %D %d %d %C %p", s1, i2, i3, i4, i5, i6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_recv %p %d %D %d %d %C %p" );
    }
    /* src/mpi/pt2pt/recv_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_recv_init", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_recv_init" );
    {
    /* src/mpi/pt2pt/recv_init.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_recv_init", "**mpi_recv_init %p %d %D %d %d %C %p", s1, i2, i3, i4, i5, i6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_recv_init %p %d %D %d %d %C %p" );
    }
    /* src/mpi/pt2pt/request_free.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_request_free", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_request_free" );
    {
    /* src/mpi/pt2pt/request_free.c */
    char s1[] = "pointer1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_request_free", "**mpi_request_free %p", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_request_free %p" );
    }
    /* src/mpi/pt2pt/request_get_status.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_request_get_status", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_request_get_status" );
    {
    /* src/mpi/pt2pt/request_get_status.c */
    int i1 = MPI_REQUEST_NULL;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_request_get_status", "**mpi_request_get_status %R %p %p", i1, s2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_request_get_status %R %p %p" );
    }
    /* src/mpi/pt2pt/rsend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_rsend", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_rsend" );
    {
    /* src/mpi/pt2pt/rsend.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_rsend", "**mpi_rsend %p %d %D %d %d %C", s1, i2, i3, i4, i5, i6 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_rsend %p %d %D %d %d %C" );
    }
    /* src/mpi/pt2pt/rsend_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_rsend_init", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_rsend_init" );
    {
    /* src/mpi/pt2pt/rsend_init.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_rsend_init", "**mpi_rsend_init %p %d %D %d %d %C %p", s1, i2, i3, i4, i5, i6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_rsend_init %p %d %D %d %d %C %p" );
    }
    /* src/mpi/pt2pt/send.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_send", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_send" );
    {
    /* src/mpi/pt2pt/send.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_send", "**mpi_send %p %d %D %d %d %C", s1, i2, i3, i4, i5, i6 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_send %p %d %D %d %d %C" );
    }
    /* src/mpi/pt2pt/send_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_send_init", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_send_init" );
    {
    /* src/mpi/pt2pt/send_init.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_send_init", "**mpi_send_init %p %d %D %d %d %C %p", s1, i2, i3, i4, i5, i6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_send_init %p %d %D %d %d %C %p" );
    }
    /* src/mpi/pt2pt/sendrecv.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_sendrecv", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_sendrecv" );
    {
    /* src/mpi/pt2pt/sendrecv.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    char s6[] = "pointer6";
    int i7 = 7;
    int i8 = MPI_INT;
    int i9 = 9;
    int i10 = 10;
    int i11 = MPI_COMM_WORLD;
    char s12[] = "pointer12";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_sendrecv", "**mpi_sendrecv %p %d %D %d %d %p %d %D %d %d %C %p", s1, i2, i3, i4, i5, s6, i7, i8, i9, i10, i11, s12 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_sendrecv %p %d %D %d %d %p %d %D %d %d %C %p" );
    }
    /* src/mpi/pt2pt/sendrecv_rep.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_sendrecv_replace", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_sendrecv_replace" );
    {
    /* src/mpi/pt2pt/sendrecv_rep.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = 6;
    int i7 = 7;
    int i8 = MPI_COMM_WORLD;
    char s9[] = "pointer9";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_sendrecv_replace", "**mpi_sendrecv_replace %p %d %D %d %d %d %d %C %p", s1, i2, i3, i4, i5, i6, i7, i8, s9 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_sendrecv_replace %p %d %D %d %d %d %d %C %p" );
    }
    /* src/mpi/pt2pt/ssend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_ssend", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_ssend" );
    {
    /* src/mpi/pt2pt/ssend.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_ssend", "**mpi_ssend %p %d %D %d %d %C", s1, i2, i3, i4, i5, i6 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_ssend %p %d %D %d %d %C" );
    }
    /* src/mpi/pt2pt/ssend_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_ssend_init", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_ssend_init" );
    {
    /* src/mpi/pt2pt/ssend_init.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
    char s7[] = "pointer7";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_ssend_init", "**mpi_ssend_init %p %d %D %d %d %C %p", s1, i2, i3, i4, i5, i6, s7 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_ssend_init %p %d %D %d %d %C %p" );
    }
    /* src/mpi/pt2pt/start.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_start", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_start" );
    {
    /* src/mpi/pt2pt/start.c */
    char s1[] = "pointer1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_start", "**mpi_start %p", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_start %p" );
    }
    /* src/mpi/pt2pt/startall.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_startall", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_startall" );
    {
    /* src/mpi/pt2pt/startall.c */
    int i1 = 1;
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_startall", "**mpi_startall %d %p", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_startall %d %p" );
    }
    /* src/mpi/pt2pt/test.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_test", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_test" );
    {
    /* src/mpi/pt2pt/test.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_test", "**mpi_test %p %p %p", s1, s2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_test %p %p %p" );
    }
    /* src/mpi/pt2pt/testall.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_testall", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_testall" );
    {
    /* src/mpi/pt2pt/testall.c */
    int i1 = 1;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_testall", "**mpi_testall %d %p %p %p", i1, s2, s3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_testall %d %p %p %p" );
    }
    /* src/mpi/pt2pt/testany.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_testany", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_testany" );
    {
    /* src/mpi/pt2pt/testany.c */
    int i1 = 1;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_testany", "**mpi_testany %d %p %p %p %p", i1, s2, s3, s4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_testany %d %p %p %p %p" );
    }
    /* src/mpi/pt2pt/testsome.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_testsome", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_testsome" );
    {
    /* src/mpi/pt2pt/testsome.c */
    int i1 = 1;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_testsome", "**mpi_testsome %d %p %p %p %p", i1, s2, s3, s4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_testsome %d %p %p %p %p" );
    }
    /* src/mpi/pt2pt/wait.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_wait", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_wait" );
    {
    /* src/mpi/pt2pt/wait.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_wait", "**mpi_wait %p %p", s1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_wait %p %p" );
    }
    /* src/mpi/pt2pt/waitall.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_waitall", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_waitall" );
    {
    /* src/mpi/pt2pt/waitall.c */
    int i1 = 1;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_waitall", "**mpi_waitall %d %p %p", i1, s2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_waitall %d %p %p" );
    }
    /* src/mpi/pt2pt/waitany.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_waitany", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_waitany" );
    {
    /* src/mpi/pt2pt/waitany.c */
    int i1 = 1;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_waitany", "**mpi_waitany %d %p %p %p", i1, s2, s3, s4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_waitany %d %p %p %p" );
    }
    /* src/mpi/pt2pt/waitsome.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_waitsome", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_waitsome" );
    {
    /* src/mpi/pt2pt/waitsome.c */
    int i1 = 1;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_waitsome", "**mpi_waitsome %d %p %p %p %p", i1, s2, s3, s4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_waitsome %d %p %p %p %p" );
    }
    /* src/mpi/rma/accumulate.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OP, "**op", 0);
    ChkMsg( err, MPI_ERR_OP, "**op" );
    /* src/mpi/rma/accumulate.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_accumulate", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_accumulate" );
    {
    /* src/mpi/rma/accumulate.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = 6;
    int i7 = MPI_INT;
    int i8 = MPI_SUM;
    int i9 = MPI_WIN_NULL;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_accumulate", "**mpi_accumulate %p %d %D %d %d %d %D %O %W", s1, i2, i3, i4, i5, i6, i7, i8, i9 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_accumulate %p %d %D %d %d %d %D %O %W" );
    }
    /* src/mpi/rma/alloc_mem.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_NO_MEM, "**allocmem", 0);
    ChkMsg( err, MPI_ERR_NO_MEM, "**allocmem" );
    /* src/mpi/rma/get.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_get", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_get" );
    {
    /* src/mpi/rma/get.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = 6;
    int i7 = MPI_INT;
    int i8 = MPI_WIN_NULL;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_get", "**mpi_get %p %d %D %d %d %d %D %W", s1, i2, i3, i4, i5, i6, i7, i8 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_get %p %d %D %d %d %d %D %W" );
    }
    /* src/mpi/rma/put.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_put", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_put" );
    {
    /* src/mpi/rma/put.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = MPI_INT;
    int i4 = 4;
    int i5 = 5;
    int i6 = 6;
    int i7 = MPI_INT;
    int i8 = MPI_WIN_NULL;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_put", "**mpi_put %p %d %D %d %d %d %D %W", s1, i2, i3, i4, i5, i6, i7, i8 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_put %p %d %D %d %d %d %D %W" );
    }
    /* src/mpi/rma/win_complete.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_complete", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_complete" );
    {
    /* src/mpi/rma/win_complete.c */
    int i1 = MPI_WIN_NULL;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_complete", "**mpi_win_complete %W", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_complete %W" );
    }
    /* src/mpi/rma/win_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_SIZE, "**rmasize", 0);
    ChkMsg( err, MPI_ERR_SIZE, "**rmasize" );
    {
    /* src/mpi/rma/win_create.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_SIZE, "**rmasize", "**rmasize %d", i1 );
    ChkMsg( err, MPI_ERR_SIZE, "**rmasize %d" );
    }
    {
    /* src/mpi/rma/win_create.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**arg", "**arg %s", s1 );
    ChkMsg( err, MPI_ERR_ARG, "**arg %s" );
    }
    /* src/mpi/rma/win_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_create", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_create" );
    {
    /* src/mpi/rma/win_create.c */
    char s1[] = "pointer1";
    int i2 = 2;
    int i3 = 3;
    int i4 = MPI_INFO_NULL;
    int i5 = MPI_COMM_WORLD;
    char s6[] = "pointer6";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_create", "**mpi_win_create %p %d %d %I %C %p", s1, i2, i3, i4, i5, s6 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_create %p %d %d %I %C %p" );
    }
    /* src/mpi/rma/win_fence.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_fence", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_fence" );
    {
    /* src/mpi/rma/win_fence.c */
    int i1 = 1;
    int i2 = MPI_WIN_NULL;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_fence", "**mpi_win_fence %A %W", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_fence %A %W" );
    }
    /* src/mpi/rma/win_free.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_free", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_free" );
    {
    /* src/mpi/rma/win_free.c */
    char s1[] = "pointer1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_free", "**mpi_win_free %p", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_free %p" );
    }
    /* src/mpi/rma/win_get_group.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_get_group", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_get_group" );
    {
    /* src/mpi/rma/win_get_group.c */
    int i1 = MPI_WIN_NULL;
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_get_group", "**mpi_win_get_group %W %p", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_get_group %W %p" );
    }
    /* src/mpi/rma/win_lock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_lock", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_lock" );
    {
    /* src/mpi/rma/win_lock.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
    int i4 = MPI_WIN_NULL;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_lock", "**mpi_win_lock %d %d %d %W", i1, i2, i3, i4 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_lock %d %d %d %W" );
    }
    /* src/mpi/rma/win_post.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_post", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_post" );
    {
    /* src/mpi/rma/win_post.c */
    int i1 = MPI_GROUP_NULL;
    int i2 = 2;
    int i3 = MPI_WIN_NULL;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_post", "**mpi_win_post %G %d %W", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_post %G %d %W" );
    }
    /* src/mpi/rma/win_test.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_test", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_test" );
    {
    /* src/mpi/rma/win_test.c */
    int i1 = MPI_WIN_NULL;
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_test", "**mpi_win_test %W %p", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_test %W %p" );
    }
    /* src/mpi/rma/win_unlock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_unlock", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_unlock" );
    {
    /* src/mpi/rma/win_unlock.c */
    int i1 = 1;
    int i2 = MPI_WIN_NULL;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_unlock", "**mpi_win_unlock %d %W", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_unlock %d %W" );
    }
    /* src/mpi/rma/win_wait.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_wait", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_wait" );
    {
    /* src/mpi/rma/win_wait.c */
    int i1 = MPI_WIN_NULL;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_win_wait", "**mpi_win_wait %W", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_win_wait %W" );
    }
    /* src/mpi/spawn/close_port.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_close_port", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_close_port" );
    {
    /* src/mpi/spawn/close_port.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_close_port", "**mpi_close_port %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_close_port %s" );
    }
    /* src/mpi/spawn/comm_accept.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_accept", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_accept" );
    {
    /* src/mpi/spawn/comm_accept.c */
    char s1[] = "string1";
    int i2 = MPI_INFO_NULL;
    int i3 = 3;
    int i4 = MPI_COMM_WORLD;
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_accept", "**mpi_comm_accept %s %I %d %C %p", s1, i2, i3, i4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_accept %s %I %d %C %p" );
    }
    /* src/mpi/spawn/comm_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_connect", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_connect" );
    {
    /* src/mpi/spawn/comm_connect.c */
    char s1[] = "string1";
    int i2 = MPI_INFO_NULL;
    int i3 = 3;
    int i4 = MPI_COMM_WORLD;
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_connect", "**mpi_comm_connect %s %I %d %C %p", s1, i2, i3, i4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_connect %s %I %d %C %p" );
    }
    /* src/mpi/spawn/comm_disconnect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_disconnect", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_disconnect" );
    {
    /* src/mpi/spawn/comm_disconnect.c */
    char s1[] = "pointer1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_disconnect", "**mpi_comm_disconnect %p", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_disconnect %p" );
    }
    /* src/mpi/spawn/comm_join.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_UNSUPPORTED_OPERATION, "**mpi_comm_join", 0);
    ChkMsg( err, MPI_ERR_UNSUPPORTED_OPERATION, "**mpi_comm_join" );
    {
    /* src/mpi/spawn/comm_join.c */
    int i1 = 1;
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_UNSUPPORTED_OPERATION, "**mpi_comm_join", "**mpi_comm_join %d %p", i1, s2 );
    ChkMsg( err, MPI_ERR_UNSUPPORTED_OPERATION, "**mpi_comm_join %d %p" );
    }
    /* src/mpi/spawn/comm_spawn.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_spawn", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_spawn" );
    {
    /* src/mpi/spawn/comm_spawn.c */
    char s1[] = "string1";
    char s2[] = "pointer2";
    int i3 = 3;
    int i4 = MPI_INFO_NULL;
    int i5 = 5;
    int i6 = MPI_COMM_WORLD;
    char s7[] = "pointer7";
    char s8[] = "pointer8";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_spawn", "**mpi_comm_spawn %s %p %d %I %d %C %p %p", s1, s2, i3, i4, i5, i6, s7, s8 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_spawn %s %p %d %I %d %C %p %p" );
    }
    /* src/mpi/spawn/comm_spawn_multiple.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_spawn_multiple", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_spawn_multiple" );
    {
    /* src/mpi/spawn/comm_spawn_multiple.c */
    int i1 = 1;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    char s5[] = "pointer5";
    int i6 = 6;
    int i7 = MPI_COMM_WORLD;
    char s8[] = "pointer8";
    char s9[] = "pointer9";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_comm_spawn_multiple", "**mpi_comm_spawn_multiple %d %p %p %p %p %d %C %p %p", i1, s2, s3, s4, s5, i6, i7, s8, s9 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_comm_spawn_multiple %d %p %p %p %p %d %C %p %p" );
    }
    /* src/mpi/spawn/lookup_name.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_lookup_name", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_lookup_name" );
    {
    /* src/mpi/spawn/lookup_name.c */
    char s1[] = "string1";
    int i2 = MPI_INFO_NULL;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_lookup_name", "**mpi_lookup_name %s %I %p", s1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_lookup_name %s %I %p" );
    }
    /* src/mpi/spawn/lookup_name.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**nonamepub", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**nonamepub" );
    /* src/mpi/spawn/open_port.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_open_port", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_open_port" );
    {
    /* src/mpi/spawn/open_port.c */
    int i1 = MPI_INFO_NULL;
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_open_port", "**mpi_open_port %I %p", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_open_port %I %p" );
    }
    /* src/mpi/spawn/publish_name.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_publish_name", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_publish_name" );
    {
    /* src/mpi/spawn/publish_name.c */
    char s1[] = "string1";
    int i2 = MPI_INFO_NULL;
    char s3[] = "string3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_publish_name", "**mpi_publish_name %s %I %s", s1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_publish_name %s %I %s" );
    }
    /* src/mpi/spawn/unpublish_name.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_unpublish_name", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_unpublish_name" );
    {
    /* src/mpi/spawn/unpublish_name.c */
    char s1[] = "string1";
    int i2 = MPI_INFO_NULL;
    char s3[] = "string3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_unpublish_name", "**mpi_unpublish_name %s %I %s", s1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_unpublish_name %s %I %s" );
    }
    /* src/mpi/topo/cart_coords.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TOPOLOGY, "**notcarttopo", 0);
    ChkMsg( err, MPI_ERR_TOPOLOGY, "**notcarttopo" );
    /* src/mpi/topo/cart_coords.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**dimsmany", 0);
    ChkMsg( err, MPI_ERR_ARG, "**dimsmany" );
    {
    /* src/mpi/topo/cart_coords.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**dimsmany", "**dimsmany %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_ARG, "**dimsmany %d %d" );
    }
    /* src/mpi/topo/cart_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_DIMS, "**dims", 0);
    ChkMsg( err, MPI_ERR_DIMS, "**dims" );
    {
    /* src/mpi/topo/cart_create.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_DIMS, "**dims", "**dims %d", i1 );
    ChkMsg( err, MPI_ERR_DIMS, "**dims %d" );
    }
    /* src/mpi/topo/cart_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**cartdim", 0);
    ChkMsg( err, MPI_ERR_ARG, "**cartdim" );
    {
    /* src/mpi/topo/cart_create.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**cartdim", "**cartdim %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_ARG, "**cartdim %d %d" );
    }
    /* src/mpi/topo/cart_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_cart_create", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_cart_create" );
    {
    /* src/mpi/topo/cart_create.c */
    int i1 = MPI_COMM_WORLD;
    int i2 = 2;
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    int i5 = 5;
    char s6[] = "pointer6";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_cart_create", "**mpi_cart_create %C %d %p %p %d %p", i1, i2, s3, s4, i5, s6 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_cart_create %C %d %p %p %d %p" );
    }
    /* src/mpi/topo/cart_map.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_DIMS, "**topotoolarge", 0);
    ChkMsg( err, MPI_ERR_DIMS, "**topotoolarge" );
    {
    /* src/mpi/topo/cart_map.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_DIMS, "**topotoolarge", "**topotoolarge %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_DIMS, "**topotoolarge %d %d" );
    }
    /* src/mpi/topo/cart_rank.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**cartcoordinvalid", 0);
    ChkMsg( err, MPI_ERR_ARG, "**cartcoordinvalid" );
    {
    /* src/mpi/topo/cart_rank.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**cartcoordinvalid", "**cartcoordinvalid %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_ARG, "**cartcoordinvalid %d %d %d" );
    }
    /* src/mpi/topo/cart_sub.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TOPOLOGY, "**notopology", 0);
    ChkMsg( err, MPI_ERR_TOPOLOGY, "**notopology" );
    /* src/mpi/topo/dims_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_DIMS, "**argarrayneg", 0);
    ChkMsg( err, MPI_ERR_DIMS, "**argarrayneg" );
    {
    /* src/mpi/topo/dims_create.c */
    char s1[] = "string1";
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_DIMS, "**argarrayneg", "**argarrayneg %s %d %d", s1, i2, i3 );
    ChkMsg( err, MPI_ERR_DIMS, "**argarrayneg %s %d %d" );
    }
    /* src/mpi/topo/dims_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_DIMS, "**dimspartition", 0);
    ChkMsg( err, MPI_ERR_DIMS, "**dimspartition" );
    /* src/mpi/topo/graph_get.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TOPOLOGY, "**notgraphtopo", 0);
    ChkMsg( err, MPI_ERR_TOPOLOGY, "**notgraphtopo" );
    /* src/mpi/topo/graph_get.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**argrange", 0);
    ChkMsg( err, MPI_ERR_ARG, "**argrange" );
    {
    /* src/mpi/topo/graph_get.c */
    char s1[] = "string1";
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**argrange", "**argrange %s %d %d", s1, i2, i3 );
    ChkMsg( err, MPI_ERR_ARG, "**argrange %s %d %d" );
    }
    /* src/mpi/topo/graph_map.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**graphnnodes", 0);
    ChkMsg( err, MPI_ERR_ARG, "**graphnnodes" );
    /* src/mpi/topo/graph_map.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_graph_map", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_graph_map" );
    {
    /* src/mpi/topo/graph_map.c */
    int i1 = MPI_COMM_WORLD;
    int i2 = 2;
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    char s5[] = "pointer5";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_graph_map", "**mpi_graph_map %C %d %p %p %p", i1, i2, s3, s4, s5 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_graph_map %C %d %p %p %p" );
    }
    /* src/mpi/topo/graphcreate.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**indexneg", 0);
    ChkMsg( err, MPI_ERR_ARG, "**indexneg" );
    {
    /* src/mpi/topo/graphcreate.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**indexneg", "**indexneg %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_ARG, "**indexneg %d %d" );
    }
    /* src/mpi/topo/graphcreate.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**indexnonmonotone", 0);
    ChkMsg( err, MPI_ERR_ARG, "**indexnonmonotone" );
    {
    /* src/mpi/topo/graphcreate.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**indexnonmonotone", "**indexnonmonotone %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_ARG, "**indexnonmonotone %d %d %d" );
    }
    /* src/mpi/topo/graphcreate.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**edgeoutrange", 0);
    ChkMsg( err, MPI_ERR_ARG, "**edgeoutrange" );
    {
    /* src/mpi/topo/graphcreate.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**edgeoutrange", "**edgeoutrange %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_ARG, "**edgeoutrange %d %d %d" );
    }
    /* src/mpi/topo/graphcreate.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**nulledge", 0);
    ChkMsg( err, MPI_ERR_ARG, "**nulledge" );
    {
    /* src/mpi/topo/graphcreate.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**nulledge", "**nulledge %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_ARG, "**nulledge %d %d" );
    }
    /* src/mpi/topo/graphcreate.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_graph_create", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_graph_create" );
    {
    /* src/mpi/topo/graphcreate.c */
    int i1 = MPI_COMM_WORLD;
    int i2 = 2;
    char s3[] = "pointer3";
    char s4[] = "pointer4";
    int i5 = 5;
    char s6[] = "pointer6";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_graph_create", "**mpi_graph_create %C %d %p %p %d %p", i1, i2, s3, s4, i5, s6 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_graph_create %C %d %p %p %d %p" );
    }
    /* src/mpi/romio/adio/ad_hfs/ad_hfs_close.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_IO, "**io", 0);
    ChkMsg( err, MPI_ERR_IO, "**io" );
    {
    /* src/mpi/romio/adio/ad_hfs/ad_hfs_close.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_IO, "**io", "**io %s", s1 );
    ChkMsg( err, MPI_ERR_IO, "**io %s" );
    }
    /* src/mpi/romio/adio/ad_hfs/ad_hfs_fcntl.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_IO, "**iopreallocrdwr", 0);
    ChkMsg( err, MPI_ERR_IO, "**iopreallocrdwr" );
    /* src/mpi/romio/adio/ad_nfs/ad_nfs_open.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BAD_FILE, "**filenamelong", 0);
    ChkMsg( err, MPI_ERR_BAD_FILE, "**filenamelong" );
    {
    /* src/mpi/romio/adio/ad_nfs/ad_nfs_open.c */
    char s1[] = "string1";
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BAD_FILE, "**filenamelong", "**filenamelong %s %d", s1, i2 );
    ChkMsg( err, MPI_ERR_BAD_FILE, "**filenamelong %s %d" );
    }
    /* src/mpi/romio/adio/ad_nfs/ad_nfs_open.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_NO_SUCH_FILE, "**filenoexist", 0);
    ChkMsg( err, MPI_ERR_NO_SUCH_FILE, "**filenoexist" );
    {
    /* src/mpi/romio/adio/ad_nfs/ad_nfs_open.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_NO_SUCH_FILE, "**filenoexist", "**filenoexist %s", s1 );
    ChkMsg( err, MPI_ERR_NO_SUCH_FILE, "**filenoexist %s" );
    }
    /* src/mpi/romio/adio/ad_nfs/ad_nfs_open.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BAD_FILE, "**filenamedir", 0);
    ChkMsg( err, MPI_ERR_BAD_FILE, "**filenamedir" );
    {
    /* src/mpi/romio/adio/ad_nfs/ad_nfs_open.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BAD_FILE, "**filenamedir", "**filenamedir %s", s1 );
    ChkMsg( err, MPI_ERR_BAD_FILE, "**filenamedir %s" );
    }
    /* src/mpi/romio/adio/ad_nfs/ad_nfs_open.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ACCESS, "**fileaccess", 0);
    ChkMsg( err, MPI_ERR_ACCESS, "**fileaccess" );
    {
    /* src/mpi/romio/adio/ad_nfs/ad_nfs_open.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ACCESS, "**fileaccess", "**fileaccess %s", s1 );
    ChkMsg( err, MPI_ERR_ACCESS, "**fileaccess %s" );
    }
    /* src/mpi/romio/adio/ad_nfs/ad_nfs_open.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_READ_ONLY, "**ioneedrd", 0);
    ChkMsg( err, MPI_ERR_READ_ONLY, "**ioneedrd" );
    /* src/mpi/romio/adio/common/ad_fstype.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_IO, "**iofstype", 0);
    ChkMsg( err, MPI_ERR_IO, "**iofstype" );
    /* src/mpi/romio/adio/common/ad_fstype.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_IO, "**iofstypeunsupported", 0);
    ChkMsg( err, MPI_ERR_IO, "**iofstypeunsupported" );
    /* src/mpi/romio/adio/common/ad_open.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_IO, "**ioagnomatch", 0);
    ChkMsg( err, MPI_ERR_IO, "**ioagnomatch" );
    /* src/mpi/romio/adio/common/ad_write_coll.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_IO, "**ioRMWrdwr", 0);
    ChkMsg( err, MPI_ERR_IO, "**ioRMWrdwr" );
    /* src/mpi/romio/adio/include/adioi_error.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_FILE, "**iofilenull", 0);
    ChkMsg( err, MPI_ERR_FILE, "**iofilenull" );
    /* src/mpi/romio/adio/include/adioi_error.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_FILE, "**iofilecorrupt", 0);
    ChkMsg( err, MPI_ERR_FILE, "**iofilecorrupt" );
    /* src/mpi/romio/mpi-io/get_bytoff.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**iobadoffset", 0);
    ChkMsg( err, MPI_ERR_ARG, "**iobadoffset" );
    /* src/mpi/romio/mpi-io/get_bytoff.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_UNSUPPORTED_OPERATION, "**ioamodeseq", 0);
    ChkMsg( err, MPI_ERR_UNSUPPORTED_OPERATION, "**ioamodeseq" );
    /* src/mpi/romio/mpi-io/get_errh.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_FILE, "**iobadfh", 0);
    ChkMsg( err, MPI_ERR_FILE, "**iobadfh" );
    /* src/mpi/romio/mpi-io/get_extent.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TYPE, "**dtypenull", 0);
    ChkMsg( err, MPI_ERR_TYPE, "**dtypenull" );
    /* src/mpi/romio/mpi-io/get_posn_sh.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_UNSUPPORTED_OPERATION, "**iosharedunsupported", 0);
    ChkMsg( err, MPI_ERR_UNSUPPORTED_OPERATION, "**iosharedunsupported" );
    /* src/mpi/romio/mpi-io/get_view.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**iodatarepnomem", 0);
    ChkMsg( err, MPI_ERR_ARG, "**iodatarepnomem" );
    /* src/mpi/romio/mpi-io/iotest.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_REQUEST, "**request", 0);
    ChkMsg( err, MPI_ERR_REQUEST, "**request" );
    /* src/mpi/romio/mpi-io/iread.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**iobadcount", 0);
    ChkMsg( err, MPI_ERR_ARG, "**iobadcount" );
    /* src/mpi/romio/mpi-io/iread.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_IO, "**ioetype", 0);
    ChkMsg( err, MPI_ERR_IO, "**ioetype" );
    /* src/mpi/romio/mpi-io/open.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_COMM, "**comm", 0);
    ChkMsg( err, MPI_ERR_COMM, "**comm" );
    /* src/mpi/romio/mpi-io/open.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_COMM, "**commnotintra", 0);
    ChkMsg( err, MPI_ERR_COMM, "**commnotintra" );
    /* src/mpi/romio/mpi-io/open.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_AMODE, "**fileamodeone", 0);
    ChkMsg( err, MPI_ERR_AMODE, "**fileamodeone" );
    /* src/mpi/romio/mpi-io/open.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_AMODE, "**fileamoderead", 0);
    ChkMsg( err, MPI_ERR_AMODE, "**fileamoderead" );
    /* src/mpi/romio/mpi-io/open.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_AMODE, "**fileamodeseq", 0);
    ChkMsg( err, MPI_ERR_AMODE, "**fileamodeseq" );
    /* src/mpi/romio/mpi-io/open.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_UNSUPPORTED_OPERATION, "**iosequnsupported", 0);
    ChkMsg( err, MPI_ERR_UNSUPPORTED_OPERATION, "**iosequnsupported" );
    /* src/mpi/romio/mpi-io/prealloc.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**iobadsize", 0);
    ChkMsg( err, MPI_ERR_ARG, "**iobadsize" );
    /* src/mpi/romio/mpi-io/rd_atallb.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_IO, "**iosplitcoll", 0);
    ChkMsg( err, MPI_ERR_IO, "**iosplitcoll" );
    /* src/mpi/romio/mpi-io/rd_atalle.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_IO, "**iosplitcollnone", 0);
    ChkMsg( err, MPI_ERR_IO, "**iosplitcollnone" );
    /* src/mpi/romio/mpi-io/read_ord.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**iosharedfailed", 0);
    ChkMsg( err, MPI_ERR_INTERN, "**iosharedfailed" );
    /* src/mpi/romio/mpi-io/seek.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**ionegoffset", 0);
    ChkMsg( err, MPI_ERR_ARG, "**ionegoffset" );
    /* src/mpi/romio/mpi-io/seek.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**iobadwhence", 0);
    ChkMsg( err, MPI_ERR_ARG, "**iobadwhence" );
    /* src/mpi/romio/mpi-io/set_view.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**iobaddisp", 0);
    ChkMsg( err, MPI_ERR_ARG, "**iobaddisp" );
    /* src/mpi/romio/mpi-io/set_view.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**iofiletype", 0);
    ChkMsg( err, MPI_ERR_ARG, "**iofiletype" );
    /* src/mpi/romio/mpi-io/set_view.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**iodispifseq", 0);
    ChkMsg( err, MPI_ERR_ARG, "**iodispifseq" );
    /* src/mpi/romio/mpi-io/set_view.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_UNSUPPORTED_DATAREP, "**unsupporteddatarep", 0);
    ChkMsg( err, MPI_ERR_UNSUPPORTED_DATAREP, "**unsupporteddatarep" );
    /* src/mpi/romio/mpi-io/write.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_READ_ONLY, "**filerdonly", 0);
    ChkMsg( err, MPI_ERR_READ_ONLY, "**filerdonly" );
    {
    /* src/mpi/romio/mpi-io/write.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_READ_ONLY, "**filerdonly", "**filerdonly %s", s1 );
    ChkMsg( err, MPI_ERR_READ_ONLY, "**filerdonly %s" );
    }
    /* src/nameserv/file/file_nameserv.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**namepubfile", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**namepubfile" );
    {
    /* src/nameserv/file/file_nameserv.c */
    char s1[] = "string1";
    char s2[] = "string2";
    char s3[] = "string3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**namepubfile", "**namepubfile %s %s %s", s1, s2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**namepubfile %s %s %s" );
    }
    /* src/nameserv/file/file_nameserv.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_NAME, "**namepubnotpub", 0);
    ChkMsg( err, MPI_ERR_NAME, "**namepubnotpub" );
    {
    /* src/nameserv/file/file_nameserv.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_NAME, "**namepubnotpub", "**namepubnotpub %s", s1 );
    ChkMsg( err, MPI_ERR_NAME, "**namepubnotpub %s" );
    }
    /* src/util/info/info_create.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_info_create", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_info_create" );
    {
    /* src/util/info/info_create.c */
    char s1[] = "pointer1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_info_create", "**mpi_info_create %p", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_info_create %p" );
    }
    /* src/util/info/info_delete.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_INFO_KEY, "**infokeynull", 0);
    ChkMsg( err, MPI_ERR_INFO_KEY, "**infokeynull" );
    /* src/util/info/info_delete.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_INFO_KEY, "**infokeylong", 0);
    ChkMsg( err, MPI_ERR_INFO_KEY, "**infokeylong" );
    /* src/util/info/info_delete.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_INFO_KEY, "**infokeyempty", 0);
    ChkMsg( err, MPI_ERR_INFO_KEY, "**infokeyempty" );
    /* src/util/info/info_delete.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_INFO_NOKEY, "**infonokey", 0);
    ChkMsg( err, MPI_ERR_INFO_NOKEY, "**infonokey" );
    {
    /* src/util/info/info_delete.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_INFO_NOKEY, "**infonokey", "**infonokey %s", s1 );
    ChkMsg( err, MPI_ERR_INFO_NOKEY, "**infonokey %s" );
    }
    /* src/util/info/info_delete.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_info_delete", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_info_delete" );
    {
    /* src/util/info/info_delete.c */
    int i1 = MPI_INFO_NULL;
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_info_delete", "**mpi_info_delete %I %p", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_info_delete %I %p" );
    }
    /* src/util/info/info_dup.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_info_dup", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_info_dup" );
    {
    /* src/util/info/info_dup.c */
    int i1 = MPI_INFO_NULL;
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_info_dup", "**mpi_info_dup %I %p", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_info_dup %I %p" );
    }
    /* src/util/info/info_get.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_INFO_VALUE, "**infovalnull", 0);
    ChkMsg( err, MPI_ERR_INFO_VALUE, "**infovalnull" );
    /* src/util/info/info_getnth.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**infonkey", 0);
    ChkMsg( err, MPI_ERR_ARG, "**infonkey" );
    {
    /* src/util/info/info_getnth.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**infonkey", "**infonkey %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_ARG, "**infonkey %d %d" );
    }
    /* src/util/info/info_getnth.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_info_get_nthkey", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_info_get_nthkey" );
    {
    /* src/util/info/info_getnth.c */
    int i1 = MPI_INFO_NULL;
    int i2 = 2;
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_info_get_nthkey", "**mpi_info_get_nthkey %I %d %p", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_info_get_nthkey %I %d %p" );
    }
    /* src/util/info/info_set.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_INFO_VALUE, "**infovallong", 0);
    ChkMsg( err, MPI_ERR_INFO_VALUE, "**infovallong" );
    /* src/util/info/info_set.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_info_set", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_info_set" );
    {
    /* src/util/info/info_set.c */
    int i1 = MPI_INFO_NULL;
    char s2[] = "pointer2";
    char s3[] = "pointer3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mpi_info_set", "**mpi_info_set %I %p %p", i1, s2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**mpi_info_set %I %p %p" );
    }
    /* src/binding/f77/addressf.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**inttoosmall", 0);
    ChkMsg( err, MPI_ERR_ARG, "**inttoosmall" );
    /* src/binding/f77/statusf2c.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**notfstatignore", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**notfstatignore" );
    /* src/binding/f77/statusc2f.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**notcstatignore", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**notcstatignore" );
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TAG, "**tag", 0);
    ChkMsg( err, MPI_ERR_TAG, "**tag" );
    {
    /* src/include/mpierrs.h */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TAG, "**tag", "**tag %d", i1 );
    ChkMsg( err, MPI_ERR_TAG, "**tag %d" );
    }
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_COUNT, "**countneg", 0);
    ChkMsg( err, MPI_ERR_COUNT, "**countneg" );
    {
    /* src/include/mpierrs.h */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_COUNT, "**countneg", "**countneg %d", i1 );
    ChkMsg( err, MPI_ERR_COUNT, "**countneg %d" );
    }
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_DISP, "**rmadisp", 0);
    ChkMsg( err, MPI_ERR_DISP, "**rmadisp" );
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BUFFER, "**bufalias", 0);
    ChkMsg( err, MPI_ERR_BUFFER, "**bufalias" );
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**nullptr", 0);
    ChkMsg( err, MPI_ERR_ARG, "**nullptr" );
    {
    /* src/include/mpierrs.h */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**nullptr", "**nullptr %s", s1 );
    ChkMsg( err, MPI_ERR_ARG, "**nullptr %s" );
    }
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**argnonpos", 0);
    ChkMsg( err, MPI_ERR_ARG, "**argnonpos" );
    {
    /* src/include/mpierrs.h */
    char s1[] = "string1";
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ARG, "**argnonpos", "**argnonpos %s %d", s1, i2 );
    ChkMsg( err, MPI_ERR_ARG, "**argnonpos %s %d" );
    }
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ROOT, "**root", 0);
    ChkMsg( err, MPI_ERR_ROOT, "**root" );
    {
    /* src/include/mpierrs.h */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_ROOT, "**root", "**root %d", i1 );
    ChkMsg( err, MPI_ERR_ROOT, "**root %d" );
    }
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_REQUEST, "**requestnotpersist", 0);
    ChkMsg( err, MPI_ERR_REQUEST, "**requestnotpersist" );
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TYPE, "**dtype", 0);
    ChkMsg( err, MPI_ERR_TYPE, "**dtype" );
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BUFFER, "**sendbuf_inplace", 0);
    ChkMsg( err, MPI_ERR_BUFFER, "**sendbuf_inplace" );
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BUFFER, "**recvbuf_inplace", 0);
    ChkMsg( err, MPI_ERR_BUFFER, "**recvbuf_inplace" );
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BUFFER, "**buf_inplace", 0);
    ChkMsg( err, MPI_ERR_BUFFER, "**buf_inplace" );
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_BUFFER, "**bufnull", 0);
    ChkMsg( err, MPI_ERR_BUFFER, "**bufnull" );
    /* src/include/mpierrs.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_COMM, "**commnull", 0);
    ChkMsg( err, MPI_ERR_COMM, "**commnull" );
    /* src/include/mpiimpl.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**nullptrtype", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**nullptrtype" );
    {
    /* src/include/mpiimpl.h */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**nullptrtype", "**nullptrtype %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**nullptrtype %s" );
    }
    /* src/mpid/ch3/src/ch3u_buffer.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TRUNCATE, "**truncate", 0);
    ChkMsg( err, MPI_ERR_TRUNCATE, "**truncate" );
    {
    /* src/mpid/ch3/src/ch3u_buffer.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TRUNCATE, "**truncate", "**truncate %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_TRUNCATE, "**truncate %d %d" );
    }
    /* src/mpid/ch3/src/ch3u_buffer.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TYPE, "**dtypemismatch", 0);
    ChkMsg( err, MPI_ERR_TYPE, "**dtypemismatch" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|pktordered", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|pktordered" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|nopktcontainermem", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|nopktcontainermem" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|ooocancelreq", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|ooocancelreq" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**nomemreq", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**nomemreq" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|postrecv", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|postrecv" );
    {
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|postrecv", "**ch3|postrecv %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|postrecv %s" );
    }
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**rsendnomatch", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**rsendnomatch" );
    {
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**rsendnomatch", "**rsendnomatch %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**rsendnomatch %d %d" );
    }
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|loadrecviov", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|loadrecviov" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|recvdata", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|recvdata" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|syncack", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|syncack" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|ctspkt", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|ctspkt" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|loadsendiov", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|loadsendiov" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|senddata", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|senddata" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|cancelresp", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|cancelresp" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|rmamsg", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|rmamsg" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**ch3|flowcntlpkt", 0);
    ChkMsg( err, MPI_ERR_INTERN, "**ch3|flowcntlpkt" );
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**ch3|unknownpkt", 0);
    ChkMsg( err, MPI_ERR_INTERN, "**ch3|unknownpkt" );
    {
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**ch3|unknownpkt", "**ch3|unknownpkt %d", i1 );
    ChkMsg( err, MPI_ERR_INTERN, "**ch3|unknownpkt %d" );
    }
    {
    /* src/mpid/ch3/src/ch3u_handle_recv_pkt.c */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
    int i4 = 4;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TRUNCATE, "**truncate", "**truncate %d %d %d %d", i1, i2, i3, i4 );
    ChkMsg( err, MPI_ERR_TRUNCATE, "**truncate %d %d %d %d" );
    }
    {
    /* src/mpid/ch3/src/ch3u_handle_recv_req.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|loadrecviov", "**ch3|loadrecviov %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|loadrecviov %s" );
    }
    {
    /* src/mpid/ch3/src/ch3u_handle_recv_req.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|recvdata", "**ch3|recvdata %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|recvdata %s" );
    }
    /* src/mpid/ch3/src/ch3u_handle_recv_req.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**ch3|badca", 0);
    ChkMsg( err, MPI_ERR_INTERN, "**ch3|badca" );
    {
    /* src/mpid/ch3/src/ch3u_handle_recv_req.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**ch3|badca", "**ch3|badca %d", i1 );
    ChkMsg( err, MPI_ERR_INTERN, "**ch3|badca %d" );
    }
    /* src/mpid/ch3/src/ch3u_handle_recv_req.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OP, "**opnotpredefined", 0);
    ChkMsg( err, MPI_ERR_OP, "**opnotpredefined" );
    {
    /* src/mpid/ch3/src/ch3u_handle_recv_req.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OP, "**opnotpredefined", "**opnotpredefined %d", i1 );
    ChkMsg( err, MPI_ERR_OP, "**opnotpredefined %d" );
    }
    /* src/mpid/ch3/src/mpid_cancel_send.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|cancelrndv", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|cancelrndv" );
    /* src/mpid/ch3/src/mpid_cancel_send.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|canceleager", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|canceleager" );
    /* src/mpid/ch3/src/mpid_cancel_send.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|cancelreq", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|cancelreq" );
    /* src/mpid/ch3/src/mpid_irecv.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**ch3|badmsgtype", 0);
    ChkMsg( err, MPI_ERR_INTERN, "**ch3|badmsgtype" );
    {
    /* src/mpid/ch3/src/mpid_irecv.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**ch3|badmsgtype", "**ch3|badmsgtype %d", i1 );
    ChkMsg( err, MPI_ERR_INTERN, "**ch3|badmsgtype %d" );
    }
    /* src/mpid/ch3/src/mpid_irsend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|eagermsg", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|eagermsg" );
    /* src/mpid/ch3/src/mpid_isend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|rtspkt", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|rtspkt" );
    /* src/mpid/ch3/src/mpid_send.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|selfsenddeadlock", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|selfsenddeadlock" );
    /* src/mpid/ch3/src/mpid_startall.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**ch3|badreqtype", 0);
    ChkMsg( err, MPI_ERR_INTERN, "**ch3|badreqtype" );
    {
    /* src/mpid/ch3/src/mpid_startall.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**ch3|badreqtype", "**ch3|badreqtype %d", i1 );
    ChkMsg( err, MPI_ERR_INTERN, "**ch3|badreqtype %d" );
    }
    /* src/mpid/ch3/src/mpid_win_complete.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**needthreads", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**needthreads" );
    /* src/mpid/ch3/src/mpid_win_fence.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OP, "**opundefined_rma", 0);
    ChkMsg( err, MPI_ERR_OP, "**opundefined_rma" );
    {
    /* src/mpid/ch3/src/mpid_win_fence.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OP, "**opundefined_rma", "**opundefined_rma %d", i1 );
    ChkMsg( err, MPI_ERR_OP, "**opundefined_rma %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_comm_spawn_multiple.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_spawn_multiple", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_spawn_multiple" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_comm_spawn_multiple.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_spawn_multiple", "**pmi_spawn_multiple %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_spawn_multiple %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_finalize.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**finalize_progress", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**finalize_progress" );
    /* src/mpid/ch3/channels/ib/src/ch3_finalize.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_finalize", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_finalize" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_finalize.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_finalize", "**pmi_finalize %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_finalize %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_init", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_init" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_init", "**pmi_init %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_init %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_get_rank", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_get_rank" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_get_rank", "**pmi_get_rank %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_get_rank %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_get_size", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_get_size" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_get_size", "**pmi_get_size %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_get_size %d" );
    }
    {
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**fail", "**fail %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**fail %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_get_my_name", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_get_my_name" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_get_my_name", "**pmi_kvs_get_my_name %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_get_my_name %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_get_id_length_max", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_get_id_length_max" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_get_id_length_max", "**pmi_get_id_length_max %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_get_id_length_max %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_get_id", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_get_id" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_get_id", "**pmi_get_id %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_get_id %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**init_vcrt", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**init_vcrt" );
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**init_getptr", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**init_getptr" );
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**init_vcrdup", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**init_vcrdup" );
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**init_progress", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**init_progress" );
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**init_ibu", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**init_ibu" );
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**init_ibu_set", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**init_ibu_set" );
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**snprintf", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**snprintf" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**snprintf", "**snprintf %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**snprintf %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_put", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_put" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_put", "**pmi_kvs_put %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_put %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_commit", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_commit" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_commit", "**pmi_kvs_commit %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_commit %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_barrier", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_barrier" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_barrier", "**pmi_barrier %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_barrier %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_get", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_get" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_get", "**pmi_kvs_get %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_get %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_isend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ibwrite", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ibwrite" );
    /* src/mpid/ch3/channels/ib/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**iov_offset", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**iov_offset" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_progress.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**iov_offset", "**iov_offset %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**iov_offset %d %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ibu_wait", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ibu_wait" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_progress.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ibu_wait", "**ibu_wait %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**ibu_wait %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**progress", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**progress" );
    /* src/mpid/ch3/channels/ib/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ibu_op", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ibu_op" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_progress.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ibu_op", "**ibu_op %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**ibu_op %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**progress_finalize", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**progress_finalize" );
    /* src/mpid/ch3/channels/ib/src/ch3_request.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**invalid_handle", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**invalid_handle" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_request.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**invalid_handle", "**invalid_handle %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**invalid_handle %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_request.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**invalid_refcount", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**invalid_refcount" );
    {
    /* src/mpid/ch3/channels/ib/src/ch3_request.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**invalid_refcount", "**invalid_refcount %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**invalid_refcount %d" );
    }
    /* src/mpid/ch3/channels/ib/src/ch3_setup_connections.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**finish_qp", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**finish_qp" );
    /* src/mpid/ch3/channels/ib/src/ibu.ibal.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**get_guids", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**get_guids" );
    /* src/mpid/ch3/channels/ib/src/ibu.ibal.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**noca", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**noca" );
    /* src/mpid/ch3/channels/ib/src/ibu.ibal.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ca_guids", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ca_guids" );
    {
    /* src/mpid/ch3/channels/ib/src/ibu.ibal.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ca_guids", "**ca_guids %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**ca_guids %s" );
    }
    /* src/mpid/ch3/channels/ib/src/ibu.ibal.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pd_alloc", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pd_alloc" );
    {
    /* src/mpid/ch3/channels/ib/src/ibu.ibal.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pd_alloc", "**pd_alloc %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pd_alloc %s" );
    }
    {
    /* src/mpid/ch3/channels/gasnet/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**init", "gasnet_init failed %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "gasnet_init failed %d" );
    }
    {
    /* src/mpid/ch3/channels/gasnet/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**init", "gasnet_attach failed %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "gasnet_attach failed %d" );
    }
    /* src/mpid/ch3/channels/rdma/src/rdma/ch3_finalize.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3_finalize", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3_finalize" );
    /* src/mpid/ch3/channels/rdma/src/rdma/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**process_group", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**process_group" );
    /* src/mpid/ch3/channels/rdma/src/rdma/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3_init", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3_init" );
    /* src/mpid/ch3/channels/rdma/src/rdma/ch3_iread.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3ireadaggressive", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3ireadaggressive" );
    /* src/mpid/ch3/channels/rdma/src/rdma/ch3_isend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3_send", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3_send" );
    /* src/mpid/ch3/channels/rdma/src/rdma/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3progress", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3progress" );
    /* src/mpid/ch3/channels/rdma/src/rdma/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**poke", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**poke" );
    /* src/mpid/ch3/channels/rdma/src/rdma/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**postpkt", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**postpkt" );
    /* src/mpid/ch3/channels/rdma/src/rdma/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**handle_read", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**handle_read" );
    /* src/mpid/ch3/channels/rdma/src/rdma/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**write_progress", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**write_progress" );
    /* src/mpid/ch3/channels/rdma/src/rdma/ch3_read_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**read_progress", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**read_progress" );
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**rdma_init", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**rdma_init" );
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**rdma_finalize", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**rdma_finalize" );
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**OpenProcess", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**OpenProcess" );
    {
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**OpenProcess", "**OpenProcess %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**OpenProcess %d %d" );
    }
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**open", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**open" );
    {
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    char s1[] = "string1";
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**open", "**open %s %d %d", s1, i2, i3 );
    ChkMsg( err, MPI_ERR_OTHER, "**open %s %d %d" );
    }
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shm_open", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shm_open" );
    {
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    char s1[] = "string1";
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shm_open", "**shm_open %s %d", s1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**shm_open %s %d" );
    }
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmget", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shmget" );
    {
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmget", "**shmget %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**shmget %d" );
    }
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**CreateFileMapping", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**CreateFileMapping" );
    {
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**CreateFileMapping", "**CreateFileMapping %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**CreateFileMapping %d" );
    }
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mmap", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mmap" );
    {
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mmap", "**mmap %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mmap %d" );
    }
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmat", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shmat" );
    {
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmat", "**shmat %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**shmat %d" );
    }
    /* src/mpid/ch3/channels/rdma/src/shm/rdma_shm_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**MapViewOfFileEx", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**MapViewOfFileEx" );
    /* src/mpid/ch3/channels/rdma/src/shmem/rdma_shmem_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**GetMemTwice", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**GetMemTwice" );
    /* src/mpid/ch3/channels/shm/src/ch3_finalize.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**finalize_progress_finalize", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**finalize_progress_finalize" );
    /* src/mpid/ch3/channels/shm/src/ch3_finalize.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**finalize_release_mem", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**finalize_release_mem" );
    /* src/mpid/ch3/channels/shm/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**strncpy", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**strncpy" );
    /* src/mpid/ch3/channels/shm/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmhost", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shmhost" );
    {
    /* src/mpid/ch3/channels/shm/src/ch3_init.c */
    char s1[] = "string1";
    char s2[] = "string2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmhost", "**shmhost %s %s", s1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**shmhost %s %s" );
    }
    /* src/mpid/ch3/channels/shm/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmgetmem", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shmgetmem" );
    /* src/mpid/ch3/channels/shm/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmctl", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shmctl" );
    {
    /* src/mpid/ch3/channels/shm/src/ch3_init.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmctl", "**shmctl %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**shmctl %d %d" );
    }
    /* src/mpid/ch3/channels/shm/src/ch3_iread.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**invalid_shmq", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**invalid_shmq" );
    /* src/mpid/ch3/channels/shm/src/ch3_isend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmwrite", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shmwrite" );
    /* src/mpid/ch3/channels/shm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shm_wait", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shm_wait" );
    /* src/mpid/ch3/channels/shm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shm_op", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shm_op" );
    {
    /* src/mpid/ch3/channels/shm/src/ch3_progress.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shm_op", "**shm_op %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**shm_op %d" );
    }
    /* src/mpid/ch3/channels/shm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**handle_written", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**handle_written" );
    /* src/mpid/ch3/channels/shm/src/shm_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmsize", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shmsize" );
    {
    /* src/mpid/ch3/channels/shm/src/shm_memory.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmsize", "**shmsize %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**shmsize %d" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_comm_accept.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_get_name_length_max", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_get_name_length_max" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3_comm_accept.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_get_name_length_max", "**pmi_kvs_get_name_length_max %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_get_name_length_max %d" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_comm_accept.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_get_key_length_max", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_get_key_length_max" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3_comm_accept.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_get_key_length_max", "**pmi_kvs_get_key_length_max %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_get_key_length_max %d" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_comm_accept.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_get_value_length_max", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_get_value_length_max" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3_comm_accept.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_get_value_length_max", "**pmi_kvs_get_value_length_max %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_get_value_length_max %d" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_comm_accept.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_create", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_create" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3_comm_accept.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_create", "**pmi_kvs_create %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_create %d" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_finalize.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|progress_finalize", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|progress_finalize" );
    /* src/mpid/ch3/channels/sock/src/ch3_finalize.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|pmi_finalize", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|pmi_finalize" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3_finalize.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|pmi_finalize", "**ch3|sock|pmi_finalize %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|pmi_finalize %d" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**init_buscard", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**init_buscard" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3_init.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pmi_kvs_get", "**pmi_kvs_get_parent %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pmi_kvs_get_parent %d" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_iread.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**vc_state", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**vc_state" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3_iread.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**vc_state", "**vc_state %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**vc_state %d" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_istartmsg.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|post_write", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|post_write" );
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**progress_sock_wait", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**progress_sock_wait" );
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**ch3|sock|badpacket", 0);
    ChkMsg( err, MPI_ERR_INTERN, "**ch3|sock|badpacket" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**ch3|sock|badpacket", "**ch3|sock|badpacket %d", i1 );
    ChkMsg( err, MPI_ERR_INTERN, "**ch3|sock|badpacket %d" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock_post_close", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock_post_close" );
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|connfailed", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|connfailed" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|connfailed", "**ch3|sock|connfailed %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|connfailed %d %d" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|strdup", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|strdup" );
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|badbuscard", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|badbuscard" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|badbuscard", "**ch3|sock|badbuscard %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|badbuscard %s" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|hostlookup", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|hostlookup" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    char s1[] = "string1";
    int i2 = 2;
    char s3[] = "string3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|hostlookup", "**ch3|sock|hostlookup %s %d %s", s1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|hostlookup %s %d %s" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|connrefused", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|connrefused" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    char s1[] = "string1";
    int i2 = 2;
    char s3[] = "string3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|connrefused", "**ch3|sock|connrefused %s %d %s", s1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|connrefused %s %d %s" );
    }
    /* src/mpid/ch3/channels/sock/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|connallocfailed", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|connallocfailed" );
    /* src/mpid/ch3/channels/sock/src/ch3i_errno.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|connclose", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|connclose" );
    /* src/mpid/ch3/channels/sock/src/ch3i_errno.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|connterm", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|connterm" );
    /* src/mpid/ch3/channels/sock/src/ch3i_errno.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**ch3|sock|badsock", 0);
    ChkMsg( err, MPI_ERR_INTERN, "**ch3|sock|badsock" );
    /* src/mpid/ch3/channels/sock/src/ch3i_errno.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_BUFFER, "**buffer", 0);
    ChkMsg( err, MPI_ERR_BUFFER, "**buffer" );
    /* src/mpid/ch3/channels/sock/src/ch3i_errno.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|addrinuse", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|addrinuse" );
    /* src/mpid/ch3/channels/sock/src/ch3i_errno.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|failure", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|failure" );
    {
    /* src/mpid/ch3/channels/sock/src/ch3i_errno.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ch3|sock|failure", "**ch3|sock|failure %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**ch3|sock|failure %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_finalize.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**finalize_boot", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**finalize_boot" );
    /* src/mpid/ch3/channels/ssm/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**init_description", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**init_description" );
    /* src/mpid/ch3/channels/ssm/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**buscard_len", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**buscard_len" );
    /* src/mpid/ch3/channels/ssm/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**buscard", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**buscard" );
    /* src/mpid/ch3/channels/ssm/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**boot_create", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**boot_create" );
    /* src/mpid/ch3/channels/ssm/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**boot_unlink", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**boot_unlink" );
    /* src/mpid/ch3/channels/ssm/src/ch3_init.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**boot_tostring", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**boot_tostring" );
    /* src/mpid/ch3/channels/ssm/src/ch3_iread.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmq", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shmq" );
    /* src/mpid/ch3/channels/ssm/src/ch3_isend.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ssmwrite", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ssmwrite" );
    /* src/mpid/ch3/channels/ssm/src/ch3_isendv.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ssmwritev", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ssmwritev" );
    /* src/mpid/ch3/channels/ssm/src/ch3_iwrite.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ca", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ca" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_iwrite.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ca", "**ca %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**ca %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shm_read_progress", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shm_read_progress" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**progress_handle_sock_op", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**progress_handle_sock_op" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**boot_recv", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**boot_recv" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**bootqmsg", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**bootqmsg" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**bootqmsg", "**bootqmsg %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**bootqmsg %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**attach_to_mem", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**attach_to_mem" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**attach_to_mem", "**attach_to_mem %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**attach_to_mem %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**MPIDI_CH3I_SHM_Attach_to_mem", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**MPIDI_CH3I_SHM_Attach_to_mem" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**MPIDI_CH3I_SHM_Attach_to_mem", "**MPIDI_CH3I_SHM_Attach_to_mem %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**MPIDI_CH3I_SHM_Attach_to_mem %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**progress_test", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**progress_test" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**handle_sock_op", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**handle_sock_op" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**test_sock_wait", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**test_sock_wait" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mqp_failure", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mqp_failure" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**progress_init", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**progress_init" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pfinal_sockclose", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pfinal_sockclose" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**MPIU_Strdup", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**MPIU_Strdup" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**business_card", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**business_card" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**business_card", "**business_card %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**business_card %s" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**argstr_shmhost", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**argstr_shmhost" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**argstr_shmq", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**argstr_shmq" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmconnect_getmem", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shmconnect_getmem" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**boot_send", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**boot_send" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**boot_detach", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**boot_detach" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**post_connect", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**post_connect" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**post_connect", "**post_connect %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**post_connect %s" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**argstr_hostd", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**argstr_hostd" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**argstr_port", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**argstr_port" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**hostlookup", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**hostlookup" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    int i1 = 1;
    int i2 = 2;
    char s3[] = "string3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**hostlookup", "**hostlookup %d %d %s", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**hostlookup %d %d %s" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**connrefused", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**connrefused" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_connect.c */
    int i1 = 1;
    int i2 = 2;
    char s3[] = "string3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**connrefused", "**connrefused %d %d %s", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**connrefused %d %d %s" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**bad_conn", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**bad_conn" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**bad_conn", "**bad_conn %p %p", s1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**bad_conn %p %p" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**bad_sock", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**bad_sock" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**bad_sock", "**bad_sock %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**bad_sock %d %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**badpacket", 0);
    ChkMsg( err, MPI_ERR_INTERN, "**badpacket" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_INTERN, "**badpacket", "**badpacket %d", i1 );
    ChkMsg( err, MPI_ERR_INTERN, "**badpacket %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**connfailed", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**connfailed" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**connfailed", "**connfailed %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**connfailed %d %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**conn_still_active", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**conn_still_active" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**invalid_listener", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**invalid_listener" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    char s1[] = "pointer1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**invalid_listener", "**invalid_listener %p", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**invalid_listener %p" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**multi_post_read", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**multi_post_read" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**multi_post_write", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**multi_post_write" );
    /* src/mpid/ch3/channels/ssm/src/ch3_progress_sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**post_sock_write_on_shm", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**post_sock_write_on_shm" );
    /* src/mpid/ch3/channels/ssm/src/ch3_shm.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmq_index", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shmq_index" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_shm.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shmq_index", "**shmq_index %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**shmq_index %d %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_shm.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pkt_type", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pkt_type" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_shm.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pkt_type", "**pkt_type %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**pkt_type %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_shm.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pkt_ptr", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pkt_ptr" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_shm.c */
    char s1[] = "pointer1";
    char s2[] = "pointer2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pkt_ptr", "**pkt_ptr %p %p", s1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**pkt_ptr %p %p" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_shm_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ftruncate", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ftruncate" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_shm_memory.c */
    char s1[] = "string1";
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ftruncate", "**ftruncate %s %d %d", s1, i2, i3 );
    ChkMsg( err, MPI_ERR_OTHER, "**ftruncate %s %d %d" );
    }
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_shm_memory.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**MapViewOfFileEx", "**MapViewOfFileEx %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**MapViewOfFileEx %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_shm_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ftok", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**ftok" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_shm_memory.c */
    char s1[] = "string1";
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**ftok", "**ftok %s %d %d", s1, i2, i3 );
    ChkMsg( err, MPI_ERR_OTHER, "**ftok %s %d %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3_shm_memory.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shm_unlink", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**shm_unlink" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3_shm_memory.c */
    char s1[] = "string1";
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**shm_unlink", "**shm_unlink %s %d", s1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**shm_unlink %s %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mqshm_create", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mqshm_create" );
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**msgget", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**msgget" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**msgget", "**msgget %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**msgget %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mq_open", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mq_open" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mq_open", "**mq_open %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mq_open %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**CreateThread", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**CreateThread" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**CreateThread", "**CreateThread %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**CreateThread %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**winwait", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**winwait" );
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mq_close", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mq_close" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mq_close", "**mq_close %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mq_close %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**msgctl", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**msgctl" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**msgctl", "**msgctl %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**msgctl %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**boot_attach", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**boot_attach" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    char s1[] = "string1";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**boot_attach", "**boot_attach %s", s1 );
    ChkMsg( err, MPI_ERR_OTHER, "**boot_attach %s" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**FindWindowEx", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**FindWindowEx" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**FindWindowEx", "**FindWindowEx %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**FindWindowEx %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mqshm_send", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mqshm_send" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**bootqmsg", "bootqmsg %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "bootqmsg %d %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mq_send", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mq_send" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mq_send", "**mq_send %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mq_send %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**msgsnd", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**msgsnd" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**msgsnd", "**msgsnd %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**msgsnd %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mqshm_receive", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mqshm_receive" );
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mq_receive", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mq_receive" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mq_receive", "**mq_receive %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**mq_receive %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**msgrcv", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**msgrcv" );
    {
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**msgrcv", "**msgrcv %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**msgrcv %d" );
    }
    /* src/mpid/ch3/channels/ssm/src/ch3i_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**nextbootmsg", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**nextbootmsg" );
    /* src/mpid/ch3/channels/ssm/src/ch3i_shm_bootstrapq.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**mqshm_unlink", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**mqshm_unlink" );
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**socket", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**socket" );
    {
    /* src/mpid/common/sock/iocp/sock.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**socket", "**socket %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**socket %d" );
    }
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**duphandle", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**duphandle" );
    {
    /* src/mpid/common/sock/iocp/sock.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**duphandle", "**duphandle %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**duphandle %d" );
    }
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**wsasock", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**wsasock" );
    {
    /* src/mpid/common/sock/iocp/sock.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**wsasock", "**wsasock %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**wsasock %d" );
    }
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock_init", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock_init" );
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**getinfo", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**getinfo" );
    {
    /* src/mpid/common/sock/iocp/sock.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**getinfo", "**getinfo %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**getinfo %d" );
    }
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**desc_len", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**desc_len" );
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock_byname", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock_byname" );
    {
    /* src/mpid/common/sock/iocp/sock.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock_byname", "**sock_byname %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock_byname %d" );
    }
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock_gethost", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock_gethost" );
    {
    /* src/mpid/common/sock/iocp/sock.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock_gethost", "**sock_gethost %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock_gethost %d" );
    }
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**iocp", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**iocp" );
    {
    /* src/mpid/common/sock/iocp/sock.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**iocp", "**iocp %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**iocp %d" );
    }
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**bad_set", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**bad_set" );
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock_create", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock_create" );
    {
    /* src/mpid/common/sock/iocp/sock.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock_create", "**sock_create %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock_create %d" );
    }
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**listen", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**listen" );
    {
    /* src/mpid/common/sock/iocp/sock.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**listen", "**listen %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**listen %d" );
    }
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**post_accept", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**post_accept" );
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock_nop_accept", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock_nop_accept" );
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**gethostbyname", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**gethostbyname" );
    {
    /* src/mpid/common/sock/iocp/sock.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**gethostbyname", "**gethostbyname %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**gethostbyname %d" );
    }
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock_connect", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock_connect" );
    {
    /* src/mpid/common/sock/iocp/sock.c */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock_connect", "**sock_connect %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock_connect %d" );
    }
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**pctwice", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**pctwice" );
    /* src/mpid/common/sock/iocp/sock.c */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock_closed", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock_closed" );
    /* src/mpid/common/sock/poll/sock_immed.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|nosock", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|nosock" );
    /* src/mpid/common/sock/poll/sock_immed.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|osnomem", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|osnomem" );
    /* src/mpid/common/sock/poll/sock_immed.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badhandle", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badhandle" );
    {
    /* src/mpid/common/sock/poll/sock_immed.i */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badhandle", "**sock|poll|badhandle %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|badhandle %d %d %d" );
    }
    /* src/mpid/common/sock/poll/sock_immed.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|accept", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|accept" );
    {
    /* src/mpid/common/sock/poll/sock_immed.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|accept", "**sock|poll|accept %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|accept %d" );
    }
    /* src/mpid/common/sock/poll/sock_immed.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|nonblock", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|nonblock" );
    {
    /* src/mpid/common/sock/poll/sock_immed.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|nonblock", "**sock|poll|nonblock %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|nonblock %d" );
    }
    /* src/mpid/common/sock/poll/sock_immed.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|nodelay", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|nodelay" );
    {
    /* src/mpid/common/sock/poll/sock_immed.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|nodelay", "**sock|poll|nodelay %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|nodelay %d" );
    }
    /* src/mpid/common/sock/poll/sock_immed.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|sockalloc", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|sockalloc" );
    /* src/mpid/common/sock/poll/sock_immed.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|connclosed", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|connclosed" );
    {
    /* src/mpid/common/sock/poll/sock_immed.i */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|connclosed", "**sock|connclosed %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|connclosed %d %d" );
    }
    /* src/mpid/common/sock/poll/sock_misc.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badhdmax", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badhdmax" );
    /* src/mpid/common/sock/poll/sock_misc.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badhdlen", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badhdlen" );
    /* src/mpid/common/sock/poll/sock_misc.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badhdbuf", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badhdbuf" );
    /* src/mpid/common/sock/poll/sock_misc.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|oserror", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|oserror" );
    {
    /* src/mpid/common/sock/poll/sock_misc.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|oserror", "**sock|poll|oserror %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|oserror %d" );
    }
    /* src/mpid/common/sock/poll/sock_misc.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badsock", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badsock" );
    /* src/mpid/common/sock/poll/sock_post.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|socket", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|socket" );
    {
    /* src/mpid/common/sock/poll/sock_post.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|socket", "**sock|poll|socket %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|socket %d" );
    }
    /* src/mpid/common/sock/poll/sock_post.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|hostres", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|hostres" );
    {
    /* src/mpid/common/sock/poll/sock_post.i */
    int i1 = 1;
    int i2 = 2;
    char s3[] = "string3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|hostres", "**sock|poll|hostres %d %d %s", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|hostres %d %d %s" );
    }
    /* src/mpid/common/sock/poll/sock_post.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|eqfail", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|eqfail" );
    {
    /* src/mpid/common/sock/poll/sock_post.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|eqfail", "**sock|poll|eqfail %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|eqfail %d" );
    }
    /* src/mpid/common/sock/poll/sock_post.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|connrefused", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|connrefused" );
    {
    /* src/mpid/common/sock/poll/sock_post.i */
    int i1 = 1;
    int i2 = 2;
    char s3[] = "string3";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|connrefused", "**sock|poll|connrefused %d %d %s", i1, i2, s3 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|connrefused %d %d %s" );
    }
    {
    /* src/mpid/common/sock/poll/sock_post.i */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|oserror", "**sock|poll|oserror %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|oserror %d %d %d" );
    }
    /* src/mpid/common/sock/poll/sock_post.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badport", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badport" );
    {
    /* src/mpid/common/sock/poll/sock_post.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badport", "**sock|badport %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badport %d" );
    }
    /* src/mpid/common/sock/poll/sock_post.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|reuseaddr", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|reuseaddr" );
    {
    /* src/mpid/common/sock/poll/sock_post.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|reuseaddr", "**sock|poll|reuseaddr %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|reuseaddr %d" );
    }
    /* src/mpid/common/sock/poll/sock_post.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|bind", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|bind" );
    {
    /* src/mpid/common/sock/poll/sock_post.i */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|bind", "**sock|poll|bind %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|bind %d %d" );
    }
    /* src/mpid/common/sock/poll/sock_post.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|listen", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|listen" );
    {
    /* src/mpid/common/sock/poll/sock_post.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|listen", "**sock|poll|listen %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|listen %d" );
    }
    /* src/mpid/common/sock/poll/sock_post.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|getport", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|getport" );
    {
    /* src/mpid/common/sock/poll/sock_post.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|getport", "**sock|poll|getport %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|getport %d" );
    }
    /* src/mpid/common/sock/poll/sock_post.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badlen", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badlen" );
    {
    /* src/mpid/common/sock/poll/sock_post.i */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
    int i4 = 4;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badlen", "**sock|badlen %d %d %d %d", i1, i2, i3, i4 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badlen %d %d %d %d" );
    }
    /* src/mpid/common/sock/poll/sock_post.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badiovn", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badiovn" );
    {
    /* src/mpid/common/sock/poll/sock_post.i */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badiovn", "**sock|badiovn %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badiovn %d %d %d" );
    }
    /* src/mpid/common/sock/poll/sock_set.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|setalloc", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|setalloc" );
    /* src/mpid/common/sock/poll/sock_set.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|pipe", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|pipe" );
    {
    /* src/mpid/common/sock/poll/sock_set.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|pipe", "**sock|poll|pipe %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|pipe %d" );
    }
    /* src/mpid/common/sock/poll/sock_set.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|pipenonblock", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|pipenonblock" );
    {
    /* src/mpid/common/sock/poll/sock_set.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|pipenonblock", "**sock|poll|pipenonblock %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|pipenonblock %d" );
    }
    /* src/mpid/common/sock/poll/sock_wait.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|connfailed", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|connfailed" );
    {
    /* src/mpid/common/sock/poll/sock_wait.i */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|connfailed", "**sock|connfailed %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|connfailed %d %d" );
    }
    /* src/mpid/common/sock/poll/sock_wait.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|unhandledstate", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|unhandledstate" );
    {
    /* src/mpid/common/sock/poll/sock_wait.i */
    int i1 = 1;
    char s2[] = "string2";
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|unhandledstate", "**sock|poll|unhandledstate %d %s", i1, s2 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|unhandledstate %d %s" );
    }
    {
    /* src/mpid/common/sock/poll/socki_util.i */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|eqfail", "**sock|poll|eqfail %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|eqfail %d %d %d" );
    }
    /* src/mpid/common/sock/poll/socki_util.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|uninit", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|uninit" );
    /* src/mpid/common/sock/poll/socki_util.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|notconnected", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|notconnected" );
    {
    /* src/mpid/common/sock/poll/socki_util.i */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|notconnected", "**sock|notconnected %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|notconnected %d %d" );
    }
    /* src/mpid/common/sock/poll/socki_util.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|closing", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|closing" );
    {
    /* src/mpid/common/sock/poll/socki_util.i */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|closing", "**sock|closing %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|closing %d %d" );
    }
    /* src/mpid/common/sock/poll/socki_util.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|reads", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|reads" );
    {
    /* src/mpid/common/sock/poll/socki_util.i */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|reads", "**sock|reads %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|reads %d %d" );
    }
    /* src/mpid/common/sock/poll/socki_util.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|writes", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|writes" );
    {
    /* src/mpid/common/sock/poll/socki_util.i */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|writes", "**sock|writes %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|writes %d %d" );
    }
    {
    /* src/mpid/common/sock/poll/socki_util.i */
    int i1 = 1;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|connfailed", "**sock|poll|connfailed %d", i1 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|connfailed %d" );
    }
    /* src/mpid/common/sock/poll/socki_util.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|closed", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|closed" );
    /* src/mpid/common/sock/poll/socki_util.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badbuf", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badbuf" );
    {
    /* src/mpid/common/sock/poll/socki_util.i */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|badbuf", "**sock|badbuf %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|badbuf %d %d" );
    }
    {
    /* src/mpid/common/sock/poll/socki_util.i */
    int i1 = 1;
    int i2 = 2;
    int i3 = 3;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|connfailed", "**sock|poll|connfailed %d %d %d", i1, i2, i3 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|connfailed %d %d %d" );
    }
    {
    /* src/mpid/common/sock/poll/socki_util.i */
    int i1 = 1;
    int i2 = 2;
     err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|osnomem", "**sock|osnomem %d %d", i1, i2 );
    ChkMsg( err, MPI_ERR_OTHER, "**sock|osnomem %d %d" );
    }
    /* src/mpid/common/sock/poll/socki_util.i */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_FATAL, "errcode::main", __LINE__, MPI_ERR_OTHER, "**sock|poll|eqmalloc", 0);
    ChkMsg( err, MPI_ERR_OTHER, "**sock|poll|eqmalloc" );
    /* src/mpid/common/datatype/mpid_datatype.h */
    err = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, "errcode::main", __LINE__, MPI_ERR_TYPE, "**dtypecommit", 0);
    ChkMsg( err, MPI_ERR_TYPE, "**dtypecommit" );
    MPI_Finalize();
    return 0;
}
